struct SIMPLE_LIST{
    struct SIMPLE_LIST* pNext;
};

struct DOUBLE_LIST{
    struct DOUBLE_LIST* pNext;
    struct DOUBLE_LIST* pPrev;
};

enum LIST_KIND_WasaList{
    KIND_SINGLE_ALLOC_WasaList			= 0x01,			// PAmalloc(), calloc(), realloc(), ::GlobalAlloc()B
    KIND_DOUBLE_ALLOC_WasaList			= 0x02,			// oAmalloc(), calloc(), realloc(), ::GlobalAlloc()B
    KIND_SINGLE_NEW_WasaList			= 0x04,			// PAnew()B
    KIND_DOUBLE_NEW_WasaList			= 0x08,			// oAnew()B
    KIND_ALLOC_WasaList					= 0x01 + 0x02,	// _WasaList `
    KIND_NEW_WasaList					= 0x04 + 0x08,	// _WasaList `
    KIND_SINGLE_WasaList				= 0x01 + 0x04,	// _WasaList `
    KIND_DOUBLE_WasaList				= 0x02 + 0x08	// _WasaList `
};

//extern enum LIST_KIND_WasaList* gpListKind_WasaList; // ̃Xg̎ނi[zB

#ifndef NDEBUG // fobO

#define CHECK_ELEMENT_WasaDbg( pElement, kind) \
	if( 0 != ( KIND_SINGLE_WasaList & kind)){ \
CHECK_MEM_WasaDbg(( struct SIMPLE_LIST*)pElement + 1, ( struct SIMPLE_LIST*)pElement + 1, sizeof( *( pElement)) - sizeof( struct SIMPLE_LIST)); \
	}else if( 0 != ( KIND_DOUBLE_WasaList & kind)){ \
CHECK_MEM_WasaDbg(( struct DOUBLE_LIST*)pElement + 1, ( struct DOUBLE_LIST*)pElement + 1, sizeof( *( pElement)) - sizeof( struct DOUBLE_LIST)); \
	}else{ \
		exit( -1); \
	}

#else // [X

#define CHECK_ELEMENT_WasaDbg( pElement, kind)

#endif
