#include <io.h>
#include <errno.h>
#include <stdio.h>
#include "Main.h"
#include "SevenZip.h"
#include "../../../_WasaLib/_WasaList.h"
#include "../../../_WasaLib/_Cover.h" // __inline ֐̂ _WasaDbg.h ̌ŃCN[h

static char gBackupPath[ MAX_PATH];		MEMINFO_WasaDbg( gBackupPath);

// rbg}bvt@C烁ɓǂݍ݁At@CTCYԂ
static __inline void FnFileToMemoryAndGetFileSize(
	char* pBmpFileName,	// 		rbg}bvt@C
	char*& pCurrentBmp,// o		rbg}bv
	int& bmpFileSize)	// o		rbg}bvt@CTCY
{
	FILE* pBmpFile = NULL;		MEMINFO_WasaDbg( pBmpFile);

	// rbg}bvt@CI[v
	FN_FOPEN( pBmpFileName, "rb", pBmpFile);
	// t@C|C^t@CTCY擾
	bmpFileSize = FnGetFileSize( pBmpFile);
	// rbg}bvm( SoCgŏނ̂ōő +3)
	FnMalloc(( void*&)pCurrentBmp, bmpFileSize + 3);
	// rbg}bvǂݍ
	FnFread( pCurrentBmp, bmpFileSize, pBmpFile);
	memset( pCurrentBmp + bmpFileSize, 0, 3);
	// rbg}bvt@CN[Y
	FN_FCLOSE( pBmpFile);
}

// vr̃rbg}bvƃJg̃rbg}bv̈قȂ镔sƂĈkf[^ɂ
static __inline void FnMakeCompressBmpAndWrite(
	char* pPrevBmp,			// 		PÕrbg}bv
	char* pCurrentBmp,		// 		݂̃rbg}bv
	int bmpFileSize,		// 		rbg}bvTCY
	FILE* pCompressBmpFile)	// o	kf[^t@C|C^
{
	char* pPrevBmpTop = pPrevBmp;
		MEMINFO_WasaDbg( pPrevBmpTop);
	char* pCurrentBmpTop = pCurrentBmp;
		MEMINFO_WasaDbg( pCurrentBmpTop);
	int biWidthCount;
		MEMINFO_WasaDbg( biWidthCount);
	int pixelNumber;
		MEMINFO_WasaDbg( pixelNumber);
	int bmpFileSize4; // SoCgEɍ킹t@CTCY
	char* pCompressBmpTop; // krbg}bv擪
		MEMINFO_WasaDbg( pCompressBmpTop);
	char* pCompressBmp; // krbg}bv
		MEMINFO_WasaDbg( pCompressBmp);
	int opaqueFlag; // stO
		MEMINFO_WasaDbg( opaqueFlag);
	int opaqueFlagCount;
		MEMINFO_WasaDbg( opaqueFlagCount);
	int count32;
		MEMINFO_WasaDbg( count32);
	int count32Number;
		MEMINFO_WasaDbg( count32Number);
	int count;
		MEMINFO_WasaDbg( count);
	int countEnd;
		MEMINFO_WasaDbg( countEnd);
	int pixelPrev;
		MEMINFO_WasaDbg( pixelPrev);
	int pixelCurrent;
		MEMINFO_WasaDbg( pixelCurrent);
	char pixelOf32[ 32 * 4];
		MEMINFO_WasaDbg( pixelOf32);
	int pixelOf32Count;
		MEMINFO_WasaDbg( pixelOf32Count);
	int tmpInt;


	pixelNumber = bmpFileSize >> 2;
	bmpFileSize4 = bmpFileSize;
	// SŊ؂Ȃꍇ
	tmpInt = 3 & bmpFileSize;
	if( tmpInt){
		pixelNumber++;
		bmpFileSize4 += 4 - tmpInt;
	}
	// kf[^őeʊm( Z̐؂̂ĕ)
	FnMalloc(( void*&)pCompressBmpTop, bmpFileSize4 + ( pixelNumber / 32 + 1) * 4);
	pCompressBmp = pCompressBmpTop;
	count32Number = pixelNumber >> 5;
	// RQŊ؂Ȃꍇ
	if( 0 != ( 31 & pixelNumber)){
		count32Number++;
	}

	biWidthCount = 0;
	// 32 Pixel [v
	for( count32 = 0; count32Number > count32; count32++){
		opaqueFlag = 0;
		opaqueFlagCount = 0;
		pixelOf32Count = 0;
		count = count32 << 7;
		countEnd = count + ( 1 << 7);
		// Pixel [v
		for( ; countEnd > count; count += 4){
			// ŏIsNZ̎̎
			if( pixelNumber == ( count >> 2)){
				break;
			}
			assert( pixelNumber > ( count >> 2));
			// sNZF擾
			CHECK_MEM_WasaDbg( NULL, pPrevBmp, sizeof( int));
			pixelPrev = *( int*)pPrevBmp;
			pPrevBmp += 4;
			CHECK_MEM_WasaDbg( NULL, pCurrentBmp, sizeof( int));
			pixelCurrent = *( int*)pCurrentBmp;
			pCurrentBmp += 4;
			// sNZقȂF̎
			if( pixelPrev != pixelCurrent){
				// srbgtO𗧂Ă
				opaqueFlag |= 1 << opaqueFlagCount;
				// ssNZFo^
				CHECK_MEM_WasaDbg( pixelOf32, pixelOf32 + pixelOf32Count, sizeof( int));
				*( int*)( pixelOf32 + pixelOf32Count) = pixelCurrent;
				pixelOf32Count += 4;
			}
			opaqueFlagCount++;
			biWidthCount++;
		}
		// kf[^kf[^ɃRs[
		CHECK_MEM_WasaDbg( pCompressBmpTop, pCompressBmp, sizeof( int));
		*( int*)pCompressBmp = opaqueFlag;
		pCompressBmp += sizeof( opaqueFlag);
		memcpy( pCompressBmp, pixelOf32, pixelOf32Count);
		pCompressBmp += pixelOf32Count;
	}

	assert( bmpFileSize4 == pPrevBmp - pPrevBmpTop);
	assert( bmpFileSize4 == pCurrentBmp - pCurrentBmpTop);
	{
		int size = pCompressBmp - pCompressBmpTop;		MEMINFO_WasaDbg( size);

		// kf[^TCY
		FnFwrite( &size, sizeof( size), pCompressBmpFile);
		// kf[^
		FnFwrite( pCompressBmpTop, size, pCompressBmpFile);
	}
	// kf[^J
	free( pCompressBmpTop);
}

// JgfBNgɂ *.bmp  *.dds t@CSĈkB
static __inline void FnCreateCompressionBitmapsFileAll( int fileNamesListHandle)
{
	int size;
MEMINFO_WasaDbg( size);
	FILE* pCompressBmpFile = NULL; // kf[^t@C|C^
MEMINFO_WasaDbg( pCompressBmpFile);
	char* pPrevBmp; // PÕrbg}bv
MEMINFO_WasaDbg( pPrevBmp);
	char* pCurrentBmp; // ݂̃rbg}bv
MEMINFO_WasaDbg( pCurrentBmp);
	int currentBmpFileSize, prevBmpFileSize;
MEMINFO_WasaDbg( currentBmpFileSize);
	struct CURRENT_FILE_NAMES_TAG* pElement, * pPrevElement;
MEMINFO_WasaDbg( pElement);

	// 擪t@C擾
	VERIFY( false != GET_HEAD_WasaList( fileNamesListHandle, &pElement));
	// rbg}bvt@C烁ɓǂݍ݁At@CTCYԂ
	FnFileToMemoryAndGetFileSize( pElement->pFileName, pCurrentBmp, currentBmpFileSize);

	// vOXo[֐
	FnInitializeProgressBar( GET_COUNT_WasaList( fileNamesListHandle));
	while( true){
		{
			char compressBmpFileName[ _MAX_PATH]; // kt@C
MEMINFO_WasaDbg( compressBmpFileName);
			char literl1[] = ".ZPM";
MEMINFO_WasaDbg( literl1);

			// kf[^t@C쐬
			strcpy( compressBmpFileName, pElement->pFileName);
			strcat( compressBmpFileName, literl1);
			// kf[^t@CI[v
			FN_FOPEN( compressBmpFileName, "wb", pCompressBmpFile);
		}
		size = strlen( pElement->pFileName);
		// rbg}bvt@CTCYkt@Cɏ
		FnFwrite( &size, sizeof( size), pCompressBmpFile);
		// rbg}bvt@Ckt@Cɏ
		FnFwrite( pElement->pFileName, size, pCompressBmpFile);
		// rbg}bvSf[^TCY
		FnFwrite( &currentBmpFileSize, sizeof( currentBmpFileSize), pCompressBmpFile);
		// rbg}bvSf[^
		FnFwrite( pCurrentBmp, currentBmpFileSize + 3, pCompressBmpFile);
		while( true){
			// vOXo[\֐
			FnDisplayProgressBar();
			// vrݒ
			pPrevBmp = pCurrentBmp;
			prevBmpFileSize = currentBmpFileSize;
			pPrevElement = pElement;
			// ̃t@C
			if( false == GET_NEXT_WasaList( fileNamesListHandle, pElement, &pElement)){
				goto LABEL_END;
			}
			// rbg}bvt@C烁ɓǂݍ݁At@CTCYԂ
			FnFileToMemoryAndGetFileSize( pElement->pFileName, pCurrentBmp, currentBmpFileSize);
			// vrƃJg̃t@CTCYقȂ鎞
			if( prevBmpFileSize != currentBmpFileSize){
				break;
			}
			// vrƃJg̃t@CgqقȂ鎞
			if( _strcmpi(( const char*)FnSearchEndPeriod(( unsigned char*)pPrevElement->pFileName), ( const char*)FnSearchEndPeriod(( unsigned char*)pElement->pFileName))){
				break;
			}

			size = strlen( pElement->pFileName);
			// rbg}bvt@CTCYkt@Cɏ
			FnFwrite( &size, sizeof( size), pCompressBmpFile);
			// rbg}bvt@Ckt@Cɏ
			FnFwrite( pElement->pFileName, size, pCompressBmpFile);
			// vr̃rbg}bvƃJg̃rbg}bv̈قȂ镔sƂĈkf[^ɂ
			FnMakeCompressBmpAndWrite( pPrevBmp, pCurrentBmp, currentBmpFileSize, pCompressBmpFile);

			// vrJ
			free( pPrevBmp);
		}
		// vrJ
		free( pPrevBmp);
		// kf[^t@CN[Y
		FN_FCLOSE( pCompressBmpFile);
	}

LABEL_END:
	// vOXo[B֐
	FnHideProgressBar();
	// vrJ
	free( pPrevBmp);
	// kf[^t@CN[Y
	FN_FCLOSE( pCompressBmpFile);
}

// JgtH_̓ʂ̃t@CSS~Ɉړ
void FnThrowOutTrashForSameKindFiles( char sameKindFiles[])
{
	int fileNamesListHandle;					MEMINFO_WasaDbg( fileNamesListHandle);
	struct CURRENT_FILE_NAMES_TAG* pElement;	MEMINFO_WasaDbg( pElement);

	// ZPM t@C~Ƀ\[găNXgɊi[
	FnGetLoadFileNames( sameKindFiles, &fileNamesListHandle);
	// 擪t@C擾
	if( false != GET_HEAD_WasaList( fileNamesListHandle, &pElement)){
		do{
			// svȃt@CݔɈړ
			FnThrowOutTrash( pElement->pFileName);
		// ̃t@C
		}while( GET_NEXT_WasaList( fileNamesListHandle, pElement, &pElement));
	}
	// t@CXg폜
	FnDeleteList( fileNamesListHandle);
}

// JgtH_̑S *.bmp *.dds  *.ZPM Ɉk
void FnCompressToZpmAll( void)
{
	int bmpFileNamesListHandle;		MEMINFO_WasaDbg( bmpFileNamesListHandle);
	int ddsFileNamesListHandle;		MEMINFO_WasaDbg( ddsFileNamesListHandle);

	// JgtH_̑S *.ZPM S~Ɉړ
	FnThrowOutTrashForSameKindFiles( "*.ZPM");
	// BMP t@C~Ƀ\[găNXgɊi[
	FnGetLoadFileNames( "*.bmp", &bmpFileNamesListHandle);
	// BMP t@C݂鎞
	if( GET_COUNT_WasaList( bmpFileNamesListHandle)){
		// JgfBNgɂ *.bmp t@CSĈkB
		FnCreateCompressionBitmapsFileAll( bmpFileNamesListHandle);
	}
	// t@CXg폜
	FnDeleteList( bmpFileNamesListHandle);

	// DDS t@C~Ƀ\[găNXgɊi[
	FnGetLoadFileNames( "*.dds", &ddsFileNamesListHandle);
	// DDS t@C݂鎞
	if( GET_COUNT_WasaList( ddsFileNamesListHandle)){
		// JgfBNgɂ *.dds t@CSĈkB
		FnCreateCompressionBitmapsFileAll( ddsFileNamesListHandle);
	}
	// t@CXg폜
	FnDeleteList( ddsFileNamesListHandle);
	// kt@C쐬\
	::MessageBox( NULL, "kt@C쐬܂B", "k", MB_OK | MB_TASKMODAL);
}

// oCgɈقȂ鐔𒲂ׂ
int FnCheckDifferentByteCount(
	unsigned int file1UInt,
	unsigned int file2UInt,
	int& differentByteCount)
{
	int count;

	for( count = 0; 4 > count; count++, file1UInt >>= 8, file2UInt >>= 8){
		if(( 0xFF & file1UInt) != ( 0xFF & file2UInt)){
			differentByteCount++;
		}
	}

	return( differentByteCount);
}

// t@C̓er
int FnCompareFiles(
	char* compareFileName1,
	char* compareFileName2)
{
	int retValue = 1;
	FILE* pFile1 = NULL;		MEMINFO_WasaDbg( pFile1);
	FILE* pFile2 = NULL;		MEMINFO_WasaDbg( pFile2);
	unsigned int file1UInt;		MEMINFO_WasaDbg( file1UInt);
	unsigned int file2UInt;		MEMINFO_WasaDbg( file2UInt);
	int file1IntReadByte, file2IntReadByte;
	int differentByteCount = 0;

	// t@CI[v
	FN_FOPEN( compareFileName1, "rb", pFile1);
	FN_FOPEN( compareFileName2, "rb", pFile2);

	while( true){
		// t@CPSoCgǂݍ
		file1IntReadByte = fread( &file1UInt, 1, sizeof( int), pFile1);
		// t@CPI[łSoCgǂݍ񂾏ꍇ
		if( sizeof( int) != file1IntReadByte){
			// ǂݍ݃G[̏ꍇ
			if( ferror( pFile1)){
				exit( -1);
			}
			// t@CQSoCgǂݍ
			file2IntReadByte = fread( &file2UInt, 1, sizeof( int), pFile2);
			// t@CQI[łSoCgǂݍ񂾏ꍇ
			if( sizeof( int) != file2IntReadByte){
				// ǂݍ݃G[̏ꍇ
				if( ferror( pFile2)){
					exit( -1);
				}
				// t@CPƃt@CQ̓ǂݍ݃oCgقȂꍇ
				if( file1IntReadByte != file2IntReadByte){
					break;
				}
				// t@CPƃt@CQ̓ǂݍ݃f[^قȂꍇ	
				if( memcmp( &file1UInt, &file2UInt, file1IntReadByte)){
					// g[^łVoCgȏقȂꍇ
					if( 7 <= FnCheckDifferentByteCount( file1UInt, file2UInt, differentByteCount)){
						break;
					}
				}
				// ꍇ
				retValue = 0;
				break;
			}
			// t@CPƃt@CQ̓ǂݍ݃f[^قȂꍇ
			break;
		}
		// t@CQSoCgǂݍ
		file2IntReadByte = fread( &file2UInt, 1, sizeof( int), pFile2);
		// t@CQI[łSoCgǂݍ񂾏ꍇ
		if( sizeof( int) != file2IntReadByte){
			// ǂݍ݃G[̏ꍇ
			if( ferror( pFile2)){
				exit( -1);
			}
			// t@CPƃt@CQ̓ǂݍ݃f[^قȂꍇ
			break;
		}
		// t@CPƃt@CQ̓ǂݍ݃f[^قȂꍇ
		if( memcmp( &file1UInt, &file2UInt, sizeof( int))){
			// g[^łVoCgȏقȂꍇ
			if( 7 <= FnCheckDifferentByteCount( file1UInt, file2UInt, differentByteCount)){
				break;
			}
		}
		// ̂SoCgǂݍ݂ɃReBj[
	}

	// t@CN[Y
	FN_FCLOSE( pFile2);
	FN_FCLOSE( pFile1);

	return( retValue);
}

// JgtH_̓ʂ̃t@CS *.zip Ɉk
void FnSevenZipForSameKindFiles( char sameKindFiles[])
{
	int ZPMFileNamesListHandle;					MEMINFO_WasaDbg( ZPMFileNamesListHandle);
	struct CURRENT_FILE_NAMES_TAG* pElement;	MEMINFO_WasaDbg( pElement);
	char zipFileName[ MAX_PATH];				MEMINFO_WasaDbg( zipFileName);
	char backupZipFileName[ MAX_PATH];				MEMINFO_WasaDbg( backupZipFileName);

	// ZPM t@C~Ƀ\[găNXgɊi[
	FnGetLoadFileNames( sameKindFiles, &ZPMFileNamesListHandle);
	// 擪t@C擾
	if( false != GET_HEAD_WasaList( ZPMFileNamesListHandle, &pElement)){
		do{
			_snprintf( zipFileName, sizeof( zipFileName), "%s.zip", pElement->pFileName);
			// t@Cyhok
			FnCompressSevenZip( pElement->pFileName, zipFileName);
			// obNAbvtH_w肳ĂȂꍇ
			if( '\0' == gBackupPath[ 0]){
				continue;
			}
			// obNAbvtH_ɓt@C *.zip ݂Ȃꍇ
			_snprintf( backupZipFileName, sizeof( backupZipFileName), "%s\\%s", gBackupPath, zipFileName);
			if( _access( backupZipFileName, 00)){
				continue;
			}
			// t@C̓eقȂꍇ
			if( FnCompareFiles( backupZipFileName, zipFileName)){
				continue;
			}
			// *.zip t@CS~Ɉړ
			FnThrowOutTrash( zipFileName);
		// ̃t@C
		}while( GET_NEXT_WasaList( ZPMFileNamesListHandle, pElement, &pElement));
	}
	// t@CXg폜
	FnDeleteList( ZPMFileNamesListHandle);
}

// JgtH_̑S *.ZPM *.wav  *.zip Ɉk
void FnCompressToZipAll( void)
{
	// obNAbvtH_w肳Ăꍇ
	if( '\0' != gBackupPath[ 0]){
		// obNAbvtH_݂Ȃꍇ
		if( _access( gBackupPath, 00)){
			// fbZ[W\
			::MessageBox( NULL, "obNAbvtH_݂܂B", "f", MB_OK | MB_TASKMODAL);
			return;
		}
	}
	// JgtH_̑S *.zip S~Ɉړ
	FnThrowOutTrashForSameKindFiles( "*.zip");
	// JgtH_̑S *.ZPM *.wav  *.zip Ɉk
	FnSevenZipForSameKindFiles( "*.ZPM");
	FnSevenZipForSameKindFiles( "*.wav");
	// kt@C쐬\
	::MessageBox( NULL, "kt@C쐬܂B", "k", MB_OK | MB_TASKMODAL);
}

// Compress.ini t@C珉ǂݍ
void FnReadCompressIniFile( void)
{
	FILE* pFile = NULL;						MEMINFO_WasaDbg( pFile);
	char fileName[] = "Compress.ini";		MEMINFO_WasaDbg( fileName);
	char lineBuffer[ 1024];					MEMINFO_WasaDbg( lineBuffer);
	char backupPathTag[] = "BackupPath=";	MEMINFO_WasaDbg( backupPathTag);

	// kt@CI[v
	FN_FOPEN( fileName, "rb", pFile);

	// s EOF ̒O܂œǂݍށB
    while( fgets( lineBuffer, sizeof( lineBuffer), pFile)){
		// BackupPath
		if( 0 == _strnicmp( lineBuffer, backupPathTag, strlen( backupPathTag))){
			// stĂꍇ
CHECK_PTR_WasaDbg( lineBuffer, lineBuffer + strlen( lineBuffer) - 2);
			if( '\r' == *( lineBuffer + strlen( lineBuffer) - 2)){
				*( lineBuffer + strlen( lineBuffer) - 2) = '\0';
			}
			memcpy( gBackupPath, lineBuffer + strlen( backupPathTag), strlen( lineBuffer) - strlen( backupPathTag));
		}
    }
    if( ferror( pFile)){
        exit( -1);
    }

	// kt@CN[Y
	FN_FCLOSE( pFile);
}
