// CN[h
#include <stddef.h>
#include <assert.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "../_WasaLib/_WasaDbg.h" // \[X̃CN[hōŌł邱ƁB
#include "../_WasaLib/_Internal_WasaList.h" // _WasaDbg.h ȍ~ŃCN[h邱ƁB

// CN[h
// O[o錾

// `FbNxB
/*#define LEVEL0*/ // XgvfH`FbN͂ȂB
#define LEVEL1 // XgvfH`FbNB

//struct SIMPLE_LIST{
//    struct SIMPLE_LIST* pNext;
//};
//
//struct DOUBLE_LIST{
//    struct DOUBLE_LIST* pNext;
//    struct DOUBLE_LIST* pPrev;
//};

//enum LIST_KIND_WasaList{
//    KIND_SINGLE_ALLOC_WasaList  = 0x01,
//    KIND_DOUBLE_ALLOC_WasaList  = 0x02,
//    KIND_SINGLE_NEW_WasaList    = 0x04,
//    KIND_DOUBLE_NEW_WasaList    = 0x08,
//    KIND_ALLOC_WasaList         = 0x01 + 0x02,
//    KIND_NEW_WasaList           = 0x04 + 0x08,
//    KIND_SINGLE_WasaList        = 0x01 + 0x04,
//    KIND_DOUBLE_WasaList        = 0x02 + 0x08
//};

// O[o錾
// O[oϐ
static void** gppListInfoHeader_WasaList = NULL; // ̃Xgwb_[𐧌䂷|C^zB
static void** gppListInfoEnd_WasaList = NULL;    // ̃XgI[𐧌䂷|C^zB
static enum LIST_KIND_WasaList* gpListKind_WasaList = NULL; // ̃Xg̎ނi[zB
static int* gpNumberOfElement_WasaList = NULL;   // Xg̗vfi[zB
static int gNumberOfList_WasaList = 0;           // XǧB
static int gNumberOfPtrArray_WasaList = 0;       // ̃Xg𐧌䂷|C^žB
static int gSizeOfReallocPtrArray_WasaList = 32; // ̃Xg𐧌䂷|C^z̍ĊmۂPʁB
static int gTruncNumber_WasaList = 0;            // |C^z̐擪炱̃Xgԍ܂ł͕K񂪋l܂ĂB
static void ( **gppFreeElementFunc_WasaList)( void*); // XgvfJ֐B
#ifndef NDEBUG
    static char gTmpBuf_WasaList[ 1024];         // e|obt@B
    static int debugCount_WasaList = 0;          // fobOJEgB
#endif
// O[oϐ
// }N

#ifdef _WINDOWS
    #define FREE_ELEMENT( p) \
	{ \
/* prev, next |C^̌̃擪ɈړB*/ \
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( p + 1); \
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( p, 1); \
		VERIFY( NULL == ::GlobalFree( p)); \
	}
#else
    #define FREE_ELEMENT( p) \
	{ \
/* prev, next |C^̌̃擪ɈړB*/ \
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( p + 1); \
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( p, 1); \
        free( p); \
	}
#endif

#ifndef NDEBUG

    // fobO

	#define CHECK_ELEMENT_WITH_SIZE_WasaDbg( listNum, pElement, size) \
		if( *( gpListKind_WasaList + ( listNum)) & KIND_SINGLE_WasaList){ \
CHECK_MEM_WasaDbg(( struct SIMPLE_LIST*)( pElement) + 1, ( struct SIMPLE_LIST*)( pElement) + 1, ( size) - sizeof( struct SIMPLE_LIST)); \
		}else if( *( gpListKind_WasaList + ( listNum)) & KIND_DOUBLE_WasaList){ \
CHECK_MEM_WasaDbg(( struct DOUBLE_LIST*)( pElement) + 1, ( struct DOUBLE_LIST*)( pElement) + 1, ( size) - sizeof( struct DOUBLE_LIST)); \
		}else{ \
			exit( -1); \
		}
		// listNum		Xgԍ
		// pElement		Xgvfւ̃|C^
		// size			XgvfTCY

    #define DELETE_LINK_PATRS_MEMINFO( pElement, size) \
	{ \
		FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pElement); \
		ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg(( pElement) + 1, ( size) - sizeof( *( pElement))); \
	}

    #define CHECK_INIT( functionName, errFileName, errLine, returnString) \
        if( gppListInfoHeader_WasaList == NULL){ \
            sprintf( gTmpBuf_WasaList, "%s( ): XgPĂ܂", functionName); \
            gTmpBuf_WasaList[ sizeof( gTmpBuf_WasaList) - 1] = NULL; \
            DISP_ERR_STRING_WasaDbg( gTmpBuf_WasaList, errFileName, errLine); \
            returnString; \
        }

    #define CHECK_LINK_NUM( listNum, functionName, errFileName, errLine, returnString) \
        if( FnCheckLinkNum_WasaList( listNum, functionName, errFileName, errLine) == false){ \
            DEBUG_BREAKPOINT; \
            returnString; \
        }

    /*__inline*/ int FnCheckLinkNum_WasaList( int listNum, char* functionName, char* errFileName, int errLine)
    {
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        if( *( gppListInfoHeader_WasaList + listNum) == NULL){
            sprintf( gTmpBuf_WasaList, "%s( param1 == ĂȂXgԍ)", functionName);
            gTmpBuf_WasaList[ sizeof( gTmpBuf_WasaList) - 1] = NULL;
            DISP_ERR_STRING_WasaDbg( gTmpBuf_WasaList, errFileName, errLine);
            return( false);
        }
        if( listNum < 0 || gNumberOfPtrArray_WasaList < listNum + 1){
            sprintf( gTmpBuf_WasaList, "%s( param1 == ͈͊ÕXgԍ)", functionName);
            gTmpBuf_WasaList[ sizeof( gTmpBuf_WasaList) - 1] = NULL;
            DISP_ERR_STRING_WasaDbg( gTmpBuf_WasaList, errFileName, errLine);
            return( false);
        }
        return( true);
    }

    #define CHECK_IN_ELEMENT( listNum, pElement, functionName, paramCount, errFileName, errLine, returnString) \
        if( FnCheckInElement_WasaList( listNum, pElement, functionName, paramCount, errFileName, errLine) == false){ \
            DEBUG_BREAKPOINT; \
            returnString; \
        }

    __inline int FnIsElement_WasaList( int listNum, void* pElement, char* functionName, char* paramCount, char* errFileName, int errLine)
    {
#ifndef LEVEL0
        struct SIMPLE_LIST* pHeader;
        struct SIMPLE_LIST* pCurrent;
        struct DOUBLE_LIST* pHeaderDbl;
        struct DOUBLE_LIST* pEndDbl;
        struct DOUBLE_LIST* pCurrentDbl;

#ifndef NDEBUG
        FnSetNull_Wasa(( void**)&pHeader);
        FnSetNull_Wasa(( void**)&pCurrent);
        FnSetNull_Wasa(( void**)&pHeaderDbl);
        FnSetNull_Wasa(( void**)&pEndDbl);
        FnSetNull_Wasa(( void**)&pCurrentDbl);
#endif

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
        if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
            // Xg̗vfł邩ǂ`FbNB
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
            pHeader = ( struct SIMPLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
//CHECK_PTR_WasaDbg( *pHeader);
CHECK_1BYTE_WasaDbg( pHeader + 1, pHeader + 1);
            for( pCurrent = pHeader->pNext; pCurrent != NULL; pCurrent = pCurrent->pNext){
                if( pCurrent == pElement){
                    return( true);
                }
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
            }
            return( false);
        }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
            pHeaderDbl = ( struct DOUBLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
            pEndDbl = ( struct DOUBLE_LIST*)*( gppListInfoEnd_WasaList + listNum);
CHECK_1BYTE_WasaDbg( pHeaderDbl + 1, pHeaderDbl + 1);
            for( pCurrentDbl = pHeaderDbl->pNext; pCurrentDbl != pEndDbl; pCurrentDbl = pCurrentDbl->pNext){
                if( pCurrentDbl == pElement){
                    return( true);
                }
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1);
            }
            return( false);
        }else{
            DEBUG_BREAKPOINT;
            return( false);
        }
        return( false);
#else
    return( true);
#endif // LEVEL0
    }

    __inline int FnCheckInElement_WasaList( int listNum, void* pElement, char* functionName, char* paramCount, char* errFileName, int errLine)
    {
#ifndef LEVEL0
        int count;

        // SẴXgœXgvfǂׂB
        for( count = 0; count < gNumberOfPtrArray_WasaList; count++){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + count));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + count);
            if( *( gppListInfoHeader_WasaList + count) == NULL){
                continue;
            }
            if( FnIsElement_WasaList( count, pElement, functionName, paramCount, errFileName, errLine) != false){
                sprintf( gTmpBuf_WasaList, "%s( %s): SẴXgɓvf܂B", functionName, paramCount);
                gTmpBuf_WasaList[ sizeof( gTmpBuf_WasaList) - 1] = NULL;
                DISP_ERR_STRING_WasaDbg( gTmpBuf_WasaList, errFileName, errLine);
                return( false);
            }
        }
#endif // LEVEL0
//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
        if( *( gpListKind_WasaList + listNum) & KIND_ALLOC_WasaList){
            if( FnAllocPtrCheck_WasaDbg( pElement, pElement) == false){
                sprintf( gTmpBuf_WasaList, "%s( %s): AP[gꂽvfł͂܂B", functionName, paramCount);
                gTmpBuf_WasaList[ sizeof( gTmpBuf_WasaList) - 1] = NULL;
                DISP_ERR_STRING_WasaDbg( gTmpBuf_WasaList, errFileName, errLine);
                return( false);
            }
        }else if( *( gpListKind_WasaList + listNum) & KIND_NEW_WasaList){
            if( FnNewPtrCheck_WasaDbg( pElement, pElement) == false){
                sprintf( gTmpBuf_WasaList, "%s( %s): new( ) Ŋmۂꂽvfł͂܂B", functionName, paramCount);
                gTmpBuf_WasaList[ sizeof( gTmpBuf_WasaList) - 1] = NULL;
                DISP_ERR_STRING_WasaDbg( gTmpBuf_WasaList, errFileName, errLine);
                return( false);
            }
        }
        return( true);
    }

    #define CHECK_ELEMENT( listNum, pElement, functionName, paramCount, errFileName, errLine, returnString) \
        if( FnCheckElement_WasaList( listNum, pElement, functionName, paramCount, errFileName, errLine) == false){ \
            DEBUG_BREAKPOINT; \
            returnString; \
        }

    __inline int FnCheckElement_WasaList( int listNum, void* pElement, char* functionName, char* paramCount, char* errFileName, int errLine)
    {
        if( FnIsElement_WasaList( listNum, pElement, functionName, paramCount, errFileName, errLine) == false){
            sprintf( gTmpBuf_WasaList, "%s( %s): Xg̗vfł͂܂B", functionName, paramCount);
            gTmpBuf_WasaList[ sizeof( gTmpBuf_WasaList) - 1] = NULL;
            DISP_ERR_STRING_WasaDbg( gTmpBuf_WasaList, errFileName, errLine);
            return( false);
        }
        return( true);
    }

    #define CHECK_DBLPTR( ppGetElement, functionName, paramCount, errFileName, errLine, returnString) \
        if( FnCheckDblptr_WasaList( ppGetElement, functionName, paramCount, errFileName, errLine) == false){ \
            DEBUG_BREAKPOINT; \
            returnString; \
        }

    __inline int FnCheckDblptr_WasaList( void** ppGetElement, char* functionName, char* paramCount, char* errFileName, int errLine)
    {
        if( ppGetElement == NULL){
            sprintf( gTmpBuf_WasaList, "%s( %s): |C^̃AhXnȂ΂Ȃ܂B",
                functionName, paramCount);
            gTmpBuf_WasaList[ sizeof( gTmpBuf_WasaList) - 1] = NULL;
            DISP_ERR_STRING_WasaDbg( gTmpBuf_WasaList, errFileName, errLine);
            return( false);
        }
        return( true);
    }

    #define CHECK_PTR( pGetElement, functionName, paramCount, errFileName, errLine, returnString) \
        if( FnCheckPtr_WasaList( pGetElement, functionName, paramCount, errFileName, errLine) == false){ \
            DEBUG_BREAKPOINT; \
            returnString; \
        }

    __inline int FnCheckPtr_WasaList( void* pGetElement, char* functionName, char* paramCount, char* errFileName, int errLine)
    {
        if( pGetElement == NULL){
            sprintf( gTmpBuf_WasaList, "%s( %s): AhXnȂ΂Ȃ܂B",
                functionName, paramCount);
            gTmpBuf_WasaList[ sizeof( gTmpBuf_WasaList) - 1] = NULL;
            DISP_ERR_STRING_WasaDbg( gTmpBuf_WasaList, errFileName, errLine);
            return( false);
        }
        return( true);
    }

    #define CHECK_LIST_KIND( listKind, functionName, paramCount, errFileName, errLine, returnString) \
        if( KIND_SINGLE_ALLOC_WasaList != listKind && KIND_DOUBLE_ALLOC_WasaList != listKind && \
        KIND_SINGLE_NEW_WasaList != listKind && KIND_DOUBLE_NEW_WasaList != listKind){ \
            DEBUG_BREAKPOINT; \
            returnString; \
        }

    //#define FREE_AND_DISP( pMem, errString, errFileName, errLine, returnString) \
    //    if( FnFreeAndDisp_WasaDbg( pMem, errString, errFileName, errLine) == false){ \
    //        DEBUG_BREAKPOINT; \
    //        returnString; \
    //    }

    __inline int FnFreeAndDisp_WasaDbg( void* pMem, char* errString, char* errFileName, int errLine)
    {
        if( FnAllocPtrCheck_WasaDbg( pMem, pMem) == false){
            DISP_ERR_STRING_WasaDbg( errString, errFileName, errLine);
            return( false);
        }
        Free_WasaDbg( pMem, errFileName, errLine);
        return( true);
    }

#ifdef __cplusplus
    #define DELETE_AND_DISP( pMem, errString, errFileName, errLine, returnString) \
        if( FnDeleteAndDisp_WasaDbg( pMem, errString, errFileName, errLine) == false){ \
            DEBUG_BREAKPOINT; \
            returnString; \
        }

    __inline int FnDeleteAndDisp_WasaDbg( void* pMem, char* errString, char* errFileName, int errLine)
    {
        if( FnNewPtrCheck_WasaDbg( pMem, pMem) == false){
            DISP_ERR_STRING_WasaDbg( errString, errFileName, errLine);
            return( false);
        }
        delete( pMem);
        return( true);
    }
#endif

    #define SET_DISP_COUNT_1( formatString, dispString) \
        FnSetDispCount1_WasaList( formatString, dispString)
    
    __inline char* FnSetDispCount1_WasaList( char* formatString, int dispString)
    {
        sprintf( gTmpBuf_WasaList, formatString, dispString);
        gTmpBuf_WasaList[ sizeof( gTmpBuf_WasaList) - 1] = NULL;
        return( gTmpBuf_WasaList);
    }

    #define SET_DEBUG_COUNT( initCount) \
        debugCount_WasaList = initCount;

    #define INCLIMENT_DEBUG_COUNT() \
        debugCount_WasaList++;

    #define CHECK_LINKLIST( listNum) \
        FnCheckLinklist_WasaList( listNum)

    void FnCheckLinklist_WasaList( int listNum)
    {
        struct SIMPLE_LIST* pCurrent;
        struct SIMPLE_LIST* pListHeader;
        struct SIMPLE_LIST* pListEnd;
        struct DOUBLE_LIST* pCurrentDbl;
        struct DOUBLE_LIST* pListDblHeader;
        struct DOUBLE_LIST* pListDblEnd;
        int numberOfElement;
        int count;

#ifndef NDEBUG
        FnSetNull_Wasa(( void**)&pCurrent);
        FnSetNull_Wasa(( void**)&pListHeader);
        FnSetNull_Wasa(( void**)&pListEnd);
        FnSetNull_Wasa(( void**)&pCurrentDbl);
        FnSetNull_Wasa(( void**)&pListDblHeader);
        FnSetNull_Wasa(( void**)&pListDblEnd);
#endif

//CHECK_PTR_WasaDbg( *( gpNumberOfElement_WasaList + listNum));
CHECK_PTR_WasaDbg( gpNumberOfElement_WasaList, gpNumberOfElement_WasaList + listNum);
        numberOfElement = *( gpNumberOfElement_WasaList + listNum);
//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
        if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
            pListHeader = ( struct SIMPLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
            pListEnd = ( struct SIMPLE_LIST*)*( gppListInfoEnd_WasaList + listNum);
            pCurrent = pListHeader;
            for( count = 1; count <= numberOfElement; count++){
                if( pCurrent == NULL){
                    DEBUG_BREAKPOINT;
                    return;
                }
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
                pCurrent = pCurrent->pNext;
            }
            if( pCurrent != pListEnd){
                DEBUG_BREAKPOINT;
                return;
            }
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
            if( pCurrent->pNext != NULL){
                DEBUG_BREAKPOINT;
                return;
            }
        }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
            pListDblHeader = ( struct DOUBLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
            pListDblEnd = ( struct DOUBLE_LIST*)*( gppListInfoEnd_WasaList + listNum);
CHECK_1BYTE_WasaDbg( pListDblHeader + 1, pListDblHeader + 1);
            pCurrentDbl = pListDblHeader->pNext;
            for( count = 1; count <= numberOfElement; count++){
                if( pCurrentDbl == NULL){
                    DEBUG_BREAKPOINT;
                    return;
                }
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1);
                pCurrentDbl = pCurrentDbl->pNext;
            }
            if( pCurrentDbl != pListDblEnd){
                DEBUG_BREAKPOINT;
                return;
            }
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1);
            if( pCurrentDbl->pNext != NULL){
                DEBUG_BREAKPOINT;
                return;
            }
CHECK_1BYTE_WasaDbg( pListDblEnd + 1, pListDblEnd + 1);
            pCurrentDbl = pListDblEnd->pPrev;
            for( count = 1; count <= numberOfElement; count++){
                if( pCurrentDbl == NULL){
                    DEBUG_BREAKPOINT;
                    return;
                }
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1);
                pCurrentDbl = pCurrentDbl->pPrev;
            }
            if( pCurrentDbl != pListDblHeader){
                DEBUG_BREAKPOINT;
                return;
            }
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1);
            if( pCurrentDbl->pPrev != NULL){
                DEBUG_BREAKPOINT;
                return;
            }
        }else{
            DEBUG_BREAKPOINT;
            return;
        }
    }

    // fobO

#else

    // [X

	#define CHECK_ELEMENT_WITH_SIZE_WasaDbg( listNum, pElement, size)
    #define DELETE_LINK_PATRS_MEMINFO( pElement, size)

//#ifdef _WINDOWS
    //#define FREE_AND_DISP( pMem, errString, errFileName, errLine, returnString) \
	//	::GlobalFree( pMem);
//#else
    //#define FREE_AND_DISP( pMem, errString, errFileName, errLine, returnString) \
    //    free( pMem)
//#endif
    #define DELETE_AND_DISP( pMem, errString, errFileName, errLine, returnString) \
        delete( pMem)
    #define SET_DISP_COUNT_1( formatString, dispString)
    #define SET_DEBUG_COUNT( initCount)
    #define INCLIMENT_DEBUG_COUNT()
    #define CHECK_INIT( functionName, errFileName, errLine, returnString)
    #define CHECK_LINKLIST( listNum)
    #define CHECK_LINK_NUM( listNum, functionName, errFileName, errLine, returnString)
    #define CHECK_ELEMENT( listNum, pElement, functionName, paramCount, errFileName, errLine, returnString)
    #define CHECK_IN_ELEMENT( listNum, pElement, functionName, paramCount, errFileName, errLine, returnString)
    #define CHECK_PTR( pGetElement, functionName, paramCount, errFileName, errLine, returnString)
    #define CHECK_DBLPTR( ppGetElement, functionName, paramCount, errFileName, errLine, returnString)
    #define CHECK_LIST_KIND( listKind, functionName, paramCount, errFileName, errLine, returnString)
    // [X

#endif

// }N
//////////////////////////////////////////////////////////////////////////////
// ̃Xg𐧌䂷|C^z̍ĊmۂPʂw肷( ftHg 10)B
//////////////////////////////////////////////////////////////////////////////
void FnSizeOfReallocPtrArray_WasaList(
    int ptrArraySize //     |C^z̍ĊmۂPʁB
#ifndef NDEBUG
    , char* errFileName,
    int errLine
#endif
)
{
#ifndef NDEBUG
    if( ptrArraySize <= 0){
        DISP_ERR_STRING_WasaDbg( "FnSizeOfReallocPtrArray_WasaList( param1 <= 0)", errFileName, errLine);
        return;
    }
#endif
    gSizeOfReallocPtrArray_WasaList = ptrArraySize;
}

//////////////////////////////////////////////////////////////////////////////
// PoXg쐬āÃXg𐧌䂷邽߂̃XgԍԂB
//////////////////////////////////////////////////////////////////////////////
// ߂l                   ȂAfalse( fobOG[\t)B
int FnCreate_WasaList(
    int* pResultNum,                    // o    Xgԍ( 0`)BȂA-1B
    enum LIST_KIND_WasaList listKind,   //     Xg̎ށB
    void ( *freeElementFunc)( void*)    //     [U[`̃XgvfJ֐
#ifndef NDEBUG
    , char* errFileName,
    int errLine
#endif
)
{
    int result = true;
    struct SIMPLE_LIST* pTmpListHeader;
    struct DOUBLE_LIST* pTmpDblListHeader;
    struct DOUBLE_LIST* pTmpDblListEnd;
    void** ppTmpListInfo;
    void* pTmpListInfo;
    int count;
    int tmpOldNum;

    CHECK_PTR( pResultNum, "FnCreate_WasaList", "param1", errFileName, errLine, return( false));
    CHECK_LIST_KIND( listKind, "FnCreate_WasaList", "param2", errFileName, errLine, return( false));
    CHECK_PTR( freeElementFunc, "FnCreate_WasaList", "param3", errFileName, errLine, return( false));

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pTmpListHeader);
    FnSetNull_Wasa(( void**)&pTmpDblListHeader);
    FnSetNull_Wasa(( void**)&pTmpDblListEnd);
    FnSetNull_Wasa(( void**)&ppTmpListInfo);
    FnSetNull_Wasa(( void**)&pTmpListInfo);
#endif

    // |C^z񒆂ŋ󂢂Ă̈TB
    for( count = gTruncNumber_WasaList; count < gNumberOfPtrArray_WasaList; count++){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + count));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + count);
        if( *( gppListInfoHeader_WasaList + count) == NULL){
            // ̋󂫗̈挟̂߂̐ݒB
            gTruncNumber_WasaList = count;
            // Xgԍ̐ݒB
//CHECK_PTR_WasaDbg( *pResultNum);
CHECK_PTR_WasaDbg( pResultNum, pResultNum);
            *pResultNum = tmpOldNum = count;
            goto LABEL1;
        }
    }
    // |C^zĊmۂׂǂB
    if( gNumberOfList_WasaList >= gNumberOfPtrArray_WasaList){
        // Xg擪ւ̃|C^zĊmہB
#ifdef _WINDOWS
        if(( ppTmpListInfo = ( void**)::GlobalAlloc( GPTR, ( gNumberOfList_WasaList + gSizeOfReallocPtrArray_WasaList) * sizeof( void*))) == NULL){
#else
        if(( ppTmpListInfo = ( void**)calloc( gNumberOfList_WasaList + gSizeOfReallocPtrArray_WasaList, sizeof( void*))) == NULL){
#endif
            *pResultNum = -1;
#ifndef NDEBUG
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", errFileName, errLine);
#else
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", __FILE__, __LINE__);
#endif
            result = false;
            goto LABEL2;
        }
        if( gNumberOfList_WasaList != 0){
            memcpy( ppTmpListInfo, gppListInfoHeader_WasaList, gNumberOfList_WasaList * sizeof( void*));
#ifdef _WINDOWS
			VERIFY( NULL == ::GlobalFree( gppListInfoHeader_WasaList));
#else
            free( gppListInfoHeader_WasaList);
#endif
        }
        gppListInfoHeader_WasaList = ppTmpListInfo;
        // XgI[ւ̃|C^zĊmہB
#ifdef _WINDOWS
		if(( ppTmpListInfo = ( void**)::GlobalAlloc( GPTR, ( gNumberOfList_WasaList + gSizeOfReallocPtrArray_WasaList) * sizeof( void*))) == NULL){
#else
        if(( ppTmpListInfo = ( void**)calloc( gNumberOfList_WasaList + gSizeOfReallocPtrArray_WasaList, sizeof( void*))) == NULL){
#endif
            *pResultNum = -1;
#ifndef NDEBUG
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", errFileName, errLine);
#else
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", __FILE__, __LINE__);
#endif
            result = false;
            goto LABEL2;
        }
        if( gNumberOfList_WasaList != 0){
            memcpy( ppTmpListInfo, gppListInfoEnd_WasaList, gNumberOfList_WasaList * sizeof( void*));
#ifdef _WINDOWS
			VERIFY( NULL == ::GlobalFree( gppListInfoEnd_WasaList));
#else
            free( gppListInfoEnd_WasaList);
#endif
        }
        gppListInfoEnd_WasaList = ppTmpListInfo;
        // Xgނւ̔zĊmہB
#ifdef _WINDOWS
        if(( pTmpListInfo = ( char*)::GlobalAlloc( GPTR, ( gNumberOfList_WasaList + gSizeOfReallocPtrArray_WasaList) * sizeof( enum LIST_KIND_WasaList))) == NULL){
#else
        if(( pTmpListInfo = ( char*)calloc( gNumberOfList_WasaList + gSizeOfReallocPtrArray_WasaList, sizeof( enum LIST_KIND_WasaList))) == NULL){
#endif
            *pResultNum = -1;
#ifndef NDEBUG
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", errFileName, errLine);
#else
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", __FILE__, __LINE__);
#endif
            result = false;
            goto LABEL2;
        }
        if( gNumberOfList_WasaList != 0){
            memcpy( pTmpListInfo, gpListKind_WasaList, gNumberOfList_WasaList * sizeof( enum LIST_KIND_WasaList));
#ifdef _WINDOWS
			VERIFY( NULL == ::GlobalFree( gpListKind_WasaList));
#else
            free( gpListKind_WasaList);
#endif
        }
        gpListKind_WasaList = ( enum LIST_KIND_WasaList*)pTmpListInfo;
        // Xg̗vfi[zĊmہB
#ifdef _WINDOWS
        if(( pTmpListInfo = ( int*)::GlobalAlloc( GPTR, ( gNumberOfList_WasaList + gSizeOfReallocPtrArray_WasaList) * sizeof( int))) == NULL){
#else
        if(( pTmpListInfo = ( int*)calloc( gNumberOfList_WasaList + gSizeOfReallocPtrArray_WasaList, sizeof( int))) == NULL){
#endif
            *pResultNum = -1;
#ifndef NDEBUG
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", errFileName, errLine);
#else
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", __FILE__, __LINE__);
#endif
            result = false;
            goto LABEL2;
        }
        if( gNumberOfList_WasaList != 0){
            memcpy( pTmpListInfo, gpNumberOfElement_WasaList, gNumberOfList_WasaList * sizeof( int));
#ifdef _WINDOWS
			VERIFY( NULL == ::GlobalFree( gpNumberOfElement_WasaList));
#else
            free( gpNumberOfElement_WasaList);
#endif
        }
        gpNumberOfElement_WasaList = ( int*)pTmpListInfo;
        // XgvfJ֐ւ̃|C^zĊmہB
#ifdef _WINDOWS
        if(( ppTmpListInfo = ( void**)::GlobalAlloc( GPTR, ( gNumberOfList_WasaList + gSizeOfReallocPtrArray_WasaList) * sizeof( void*))) == NULL){
#else
        if(( ppTmpListInfo = ( void**)calloc( gNumberOfList_WasaList + gSizeOfReallocPtrArray_WasaList, sizeof( void*))) == NULL){
#endif
            *pResultNum = -1;
#ifndef NDEBUG
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", errFileName, errLine);
#else
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", __FILE__, __LINE__);
#endif
            result = false;
            goto LABEL2;
        }
        if( gNumberOfList_WasaList != 0){
            memcpy( ppTmpListInfo, gppFreeElementFunc_WasaList, gNumberOfList_WasaList * sizeof( void*));
#ifdef _WINDOWS
			VERIFY( NULL == ::GlobalFree( gppFreeElementFunc_WasaList));
#else
            free( gppFreeElementFunc_WasaList);
#endif
        }
        gppFreeElementFunc_WasaList = ( void ( **)( void*))ppTmpListInfo;
        // Ċmی̃TCYi[B
        gNumberOfPtrArray_WasaList += gSizeOfReallocPtrArray_WasaList;
    }
    // Xgԍ̐ݒB
    *pResultNum = tmpOldNum = gNumberOfList_WasaList;

    LABEL1:
    // Xg̃JEgCNgB
    gNumberOfList_WasaList++;
    if( listKind == KIND_SINGLE_ALLOC_WasaList || listKind == KIND_SINGLE_NEW_WasaList){
        // VȃXgwb_[̊mہB
#ifdef _WINDOWS
		if(( pTmpListHeader = ( struct SIMPLE_LIST*)::GlobalAlloc( GMEM_FIXED, sizeof( struct SIMPLE_LIST))) == NULL){
#else
		if(( pTmpListHeader = ( struct SIMPLE_LIST*)malloc( sizeof( struct SIMPLE_LIST))) == NULL){
#endif
            *pResultNum = -1;
#ifndef NDEBUG
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", errFileName, errLine);
#else
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", __FILE__, __LINE__);
#endif
            result = false;
            goto LABEL2;
        }
// 񂩂 prev, next |C^폜B
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pTmpListHeader);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pTmpListHeader + 1, 1);
        // VȃXg̃wb_[̒`B
//CHECK_PTR_WasaDbg( *pTmpListHeader);
CHECK_1BYTE_WasaDbg( pTmpListHeader + 1, pTmpListHeader + 1);
        pTmpListHeader->pNext = NULL;
        // mۂXgwb_[|C^zŎwB
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + tmpOldNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + tmpOldNum);
        *( gppListInfoHeader_WasaList + tmpOldNum) = pTmpListHeader;
        
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + tmpOldNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + tmpOldNum);
        *( gppListInfoEnd_WasaList + tmpOldNum) = pTmpListHeader;
        // mۂXgނ̒`B
//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + tmpOldNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + tmpOldNum);
        *( gpListKind_WasaList + tmpOldNum) = listKind;
    }else if( listKind == KIND_DOUBLE_ALLOC_WasaList || listKind == KIND_DOUBLE_NEW_WasaList){
        // VȃXgwb_[̊mہB
#ifdef _WINDOWS
		if(( pTmpDblListHeader = ( struct DOUBLE_LIST*)::GlobalAlloc( GMEM_FIXED, sizeof( struct DOUBLE_LIST))) == NULL){
#else
		if(( pTmpDblListHeader = ( struct DOUBLE_LIST*)malloc( sizeof( struct DOUBLE_LIST))) == NULL){
#endif
            *pResultNum = -1;
#ifndef NDEBUG
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", errFileName, errLine);
#else
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", __FILE__, __LINE__);
#endif
            result = false;
            goto LABEL2;
        }
// 񂩂 prev, next |C^폜B
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pTmpDblListHeader);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pTmpDblListHeader + 1, 1);
        // VȃXgGh̊mہB
#ifdef _WINDOWS
		if(( pTmpDblListEnd = ( struct DOUBLE_LIST*)::GlobalAlloc( GMEM_FIXED, sizeof( struct DOUBLE_LIST))) == NULL){
#else
		if(( pTmpDblListEnd = ( struct DOUBLE_LIST*)malloc( sizeof( struct DOUBLE_LIST))) == NULL){
#endif
            *pResultNum = -1;
#ifndef NDEBUG
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", errFileName, errLine);
#else
            DISP_ERR_STRING_WasaDbg( "FnCreate_WasaList( ): ܂B", __FILE__, __LINE__);
#endif
            result = false;
            goto LABEL2;
        }
// 񂩂 prev, next |C^폜B
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pTmpDblListEnd);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pTmpDblListEnd + 1, 1);
        // VȃXgwb_[̒`B
CHECK_1BYTE_WasaDbg( pTmpDblListHeader + 1, pTmpDblListHeader + 1);
        pTmpDblListHeader->pPrev = NULL;
        pTmpDblListHeader->pNext = pTmpDblListEnd;
        // VȃXgGh̒`B
CHECK_1BYTE_WasaDbg( pTmpDblListEnd + 1, pTmpDblListEnd + 1);
        pTmpDblListEnd->pPrev = pTmpDblListHeader;
        pTmpDblListEnd->pNext = NULL;
        
        // mۂXgwb_[|C^zŎwB
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + tmpOldNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + tmpOldNum);
        *( gppListInfoHeader_WasaList + tmpOldNum) = pTmpDblListHeader;
        // ӁFVONXg͏I[vfw_uNXg̓XgGhwB
        //       ( ̕fȂ)
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + tmpOldNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + tmpOldNum);
        *( gppListInfoEnd_WasaList + tmpOldNum) = pTmpDblListEnd;
        // mۂXgނ̒`B
//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + tmpOldNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + tmpOldNum);
        *( gpListKind_WasaList + tmpOldNum) = listKind;
    }else{
#ifndef NDEBUG
		DISP_ERR_STRING_WasaDbg(
			"FnCreate_WasaList(\n"
			"    param2 != KIND_SINGLE_ALLOC_WasaList &&\n"
			"    param2 != KIND_DOUBLE_ALLOC_WasaList &&\n"
			"    param2 != KIND_SINGLE_NEW_WasaList &&\n"
			"    param2 != KIND_DOUBLE_NEW_WasaList)", errFileName, errLine);
#else
		DISP_ERR_STRING_WasaDbg(
			"FnCreate_WasaList(\n"
			"    param2 != KIND_SINGLE_ALLOC_WasaList &&\n"
			"    param2 != KIND_DOUBLE_ALLOC_WasaList &&\n"
			"    param2 != KIND_SINGLE_NEW_WasaList &&\n"
			"    param2 != KIND_DOUBLE_NEW_WasaList)", __FILE__, __LINE__);
#endif
        return( false);
    }
    // XgvfJ֐̓o^B
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + *pResultNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + *pResultNum);
    *( gppFreeElementFunc_WasaList + *pResultNum) = freeElementFunc;
    // Xg̐`FbN( *( gpNumberOfElement_WasaList + *pResultNum) 񃋁[vă`FbN)B
    CHECK_LINKLIST( *pResultNum);

    LABEL2:
    return( result);
}

//////////////////////////////////////////////////////////////////////////////
// Xg폜( vf͑SĊJ)B
//////////////////////////////////////////////////////////////////////////////
void FnDelete_WasaList(
    int* pListNum
#ifndef NDEBUG
    , char* errFileName,
    int errLine
#endif
)
{
    struct SIMPLE_LIST* pCurrent;
    struct SIMPLE_LIST* pNext;
    struct DOUBLE_LIST* pCurrentDbl;
    struct DOUBLE_LIST* pNextDbl;

    CHECK_INIT( "FnDelete_WasaList", errFileName, errLine, return);
//CHECK_PTR_WasaDbg( *pListNum);
CHECK_PTR_WasaDbg( pListNum, pListNum);
    CHECK_LINK_NUM( *pListNum, "FnDelete_WasaList", errFileName, errLine, return);

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pCurrent);
    FnSetNull_Wasa(( void**)&pNext);
    FnSetNull_Wasa(( void**)&pCurrentDbl);
    FnSetNull_Wasa(( void**)&pNextDbl);
#endif

    /*SET_DEBUG_COUNT( 1);*/
//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + *pListNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + *pListNum);
    if( *( gpListKind_WasaList + *pListNum) & KIND_SINGLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + *pListNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + *pListNum);
        pCurrent = ( struct SIMPLE_LIST*)*( gppListInfoHeader_WasaList + *pListNum);
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
        pNext = pCurrent->pNext;
        // Xgwb_[J
//#ifdef _WINDOWS
		//VERIFY( NULL == ::GlobalFree( pCurrent));
//#else
        //free( pCurrent);
//#endif
		FREE_ELEMENT( pCurrent);

        for( pCurrent = pNext; pCurrent != NULL; pCurrent = pNext){
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
            pNext = pCurrent->pNext;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrent + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrent, 1);
            // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + *pListNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + *pListNum);
            ( *( gppFreeElementFunc_WasaList + *pListNum))( pCurrent);
            /*INCLIMENT_DEBUG_COUNT();*/
        }
    }else if( *( gpListKind_WasaList + *pListNum) & KIND_DOUBLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + *pListNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + *pListNum);
        pCurrentDbl = ( struct DOUBLE_LIST*)*( gppListInfoHeader_WasaList + *pListNum);
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1);
        pNextDbl = pCurrentDbl->pNext;
//// prev, next |C^̌̃擪ɈړB
//FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl + 1);
//ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl, 1);
        // Xgwb_[J
//#ifdef _WINDOWS
		//VERIFY( NULL == ::GlobalFree( pCurrentDbl));
//#else
        //free( pCurrentDbl);
//#endif
		FREE_ELEMENT( pCurrentDbl);

        for( pCurrentDbl = pNextDbl; pCurrentDbl->pNext != NULL; pCurrentDbl = pNextDbl){
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1); // 擪N񂪂Ȃ̂
            pNextDbl = pCurrentDbl->pNext;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl, 1);
            // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + *pListNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + *pListNum);
            ( *( gppFreeElementFunc_WasaList + *pListNum))( pCurrentDbl);
            /*INCLIMENT_DEBUG_COUNT();*/
        }
//// prev, next |C^̌̃擪ɈړB
//FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl + 1);
//ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl, 1);
        // XgGhJ
//#ifdef _WINDOWS
		//VERIFY( NULL == ::GlobalFree( pCurrentDbl));
//#else
        //free( pCurrentDbl);
//#endif
		FREE_ELEMENT( pCurrentDbl);
    }else{
        DEBUG_BREAKPOINT;
        return;
    }
    // ݏĂ郊XgɊւO[oϐ̏B
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + *pListNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + *pListNum);
    *( gppListInfoHeader_WasaList + *pListNum) = NULL;
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + *pListNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + *pListNum);
    *( gppListInfoEnd_WasaList + *pListNum) = NULL;
//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + *pListNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + *pListNum);
    *( gpListKind_WasaList + *pListNum) = ( enum LIST_KIND_WasaList)0x00;
//CHECK_PTR_WasaDbg( *( gpNumberOfElement_WasaList + *pListNum));
CHECK_PTR_WasaDbg( gpNumberOfElement_WasaList, gpNumberOfElement_WasaList + *pListNum);
    *( gpNumberOfElement_WasaList + *pListNum) = 0;
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + *pListNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + *pListNum);
    *( gppFreeElementFunc_WasaList + *pListNum) = NULL;
    // XgfNgB
    gNumberOfList_WasaList--;
    assert( gNumberOfList_WasaList >= 0);
    // ̋󂫗̈挟̂߂̐ݒB
//CHECK_PTR_WasaDbg( *pListNum);
CHECK_PTR_WasaDbg( pListNum, pListNum);
    if( gTruncNumber_WasaList > *pListNum){
        gTruncNumber_WasaList = *pListNum;
    }
    // XgSĊJꂽA|C^zJAO[oϐB
    if( gNumberOfList_WasaList == 0){
        // W[̕ϐȂ̂Ń`FbNȂB
#ifdef _WINDOWS
		VERIFY( NULL == ::GlobalFree( gppListInfoHeader_WasaList));
		VERIFY( NULL == ::GlobalFree( gppListInfoEnd_WasaList));
		VERIFY( NULL == ::GlobalFree( gpListKind_WasaList));
		VERIFY( NULL == ::GlobalFree( gpNumberOfElement_WasaList));
		VERIFY( NULL == ::GlobalFree( gppFreeElementFunc_WasaList));
#else
        free( gppListInfoHeader_WasaList);
        free( gppListInfoEnd_WasaList);
        free( gpListKind_WasaList);
        free( gpNumberOfElement_WasaList);
        free( gppFreeElementFunc_WasaList);
#endif
        gppListInfoHeader_WasaList = NULL;
        gppListInfoEnd_WasaList = NULL;
        gpListKind_WasaList = NULL;
        gpNumberOfElement_WasaList = NULL;
        gppFreeElementFunc_WasaList = NULL;
        assert( gNumberOfList_WasaList == 0);
        gNumberOfPtrArray_WasaList = 0;
        gSizeOfReallocPtrArray_WasaList = 10;
        gTruncNumber_WasaList = 0;
    }
	// XgԍB
//CHECK_PTR_WasaDbg( *pListNum);
CHECK_PTR_WasaDbg( pListNum, pListNum);
	*pListNum = -1;
}

//////////////////////////////////////////////////////////////////////////////
// 擪ɗvf}B
//////////////////////////////////////////////////////////////////////////////
// ߂l                   Xg䃁mۂłȂAfalseB
void FnAddHead_WasaList(
    int listNum,
    void* pAddElement	//      mۍς݂̃Xgvfւ̃|C^B
#ifndef NDEBUG
	, int size,
    char* errFileName,
    int errLine
#endif
)
{
/*CHECK_MEM_FLAG_OFF_WasaDbg;*/

    struct SIMPLE_LIST* pTmpList;
    struct SIMPLE_LIST* pListHeader;
    struct DOUBLE_LIST* pTmpDblList;
    struct DOUBLE_LIST* pListDblHeader;

    CHECK_INIT( "FnAddHead_WasaList", errFileName, errLine, return);
    CHECK_LINK_NUM( listNum, "FnAddHead_WasaList", errFileName, errLine, return);
    CHECK_PTR( pAddElement, "FnAddHead_WasaList", "param2", errFileName, errLine, return);
    CHECK_IN_ELEMENT( listNum, pAddElement, "FnAddHead_WasaList", "param2", errFileName, errLine, return);

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pTmpList);
    FnSetNull_Wasa(( void**)&pListHeader);
    FnSetNull_Wasa(( void**)&pTmpDblList);
    FnSetNull_Wasa(( void**)&pListDblHeader);
#endif

    // PNXgłB
//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
        pTmpList = ( struct SIMPLE_LIST*)pAddElement;
        // N̕tւB
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        pListHeader = ( struct SIMPLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
//CHECK_PTR_WasaDbg( *pTmpList);
CHECK_1BYTE_WasaDbg( pTmpList + 1, pTmpList + 1);
//CHECK_PTR_WasaDbg( *pListHeader);
CHECK_1BYTE_WasaDbg( pListHeader + 1, pListHeader + 1);
        pTmpList->pNext = pListHeader->pNext;
        pListHeader->pNext = pTmpList;
        // XgI[ɑ}AXgGhw|C^z̍Ē`B
        if( pTmpList->pNext == NULL){
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
            *( gppListInfoEnd_WasaList + listNum) = pAddElement;
        }
    // oNXgłB
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
        pTmpDblList = ( struct DOUBLE_LIST*)pAddElement;
        // N̕tւB
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        pListDblHeader = ( struct DOUBLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
CHECK_1BYTE_WasaDbg( pTmpDblList + 1, pTmpDblList + 1);
        pTmpDblList->pPrev = pListDblHeader;
CHECK_1BYTE_WasaDbg( pListDblHeader + 1, pListDblHeader + 1);
        pTmpDblList->pNext = pListDblHeader->pNext;
CHECK_1BYTE_WasaDbg( pTmpDblList->pNext + 1, pTmpDblList->pNext + 1);
        pTmpDblList->pNext->pPrev = pTmpDblList;
        pListDblHeader->pNext = pTmpDblList;
// 񂩂 prev, next |C^폜B
//FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pTmpDblList);
//ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pTmpDblList + 1, size - sizeof( *pTmpDblList));
DELETE_LINK_PATRS_MEMINFO( pTmpDblList, size);
        // XgGh͕ύXȂ̂ŃXgGhw|C^z̍Ē`͕KvȂB
    }else{
        DEBUG_BREAKPOINT;
		goto LABEL1;
    }
    // XgvfCNgB
//CHECK_PTR_WasaDbg( *( gpNumberOfElement_WasaList + listNum));
CHECK_PTR_WasaDbg( gpNumberOfElement_WasaList, gpNumberOfElement_WasaList + listNum);
    *( gpNumberOfElement_WasaList + listNum) += 1;

LABEL1:
// Xg̐`FbN( *( gpNumberOfElement_WasaList + listNum) 񃋁[vă`FbN)B
CHECK_LINKLIST( listNum);
/*CHECK_MEM_FLAG_ON_WasaDbg;*/
}

//////////////////////////////////////////////////////////////////////////////
// I[ɃXgvf}B
//////////////////////////////////////////////////////////////////////////////
// ߂l                   Xg䃁mۂłȂAfalseB
void FnAddTail_WasaList(
    int listNum,
    void* pAddElement	//      mۍς݂̃Xgvfւ̃|C^B
#ifndef NDEBUG
	, int size,			//      mۍς݂̃XgvfTCY
    char* errFileName,
    int errLine
#endif
)
{
/*CHECK_MEM_FLAG_OFF_WasaDbg;*/

    struct SIMPLE_LIST* pSimpleList;
    struct SIMPLE_LIST* pListEnd;
    struct DOUBLE_LIST* pDblList;
    struct DOUBLE_LIST* pListDblEnd;

    CHECK_INIT( "FnAddTail_WasaList", errFileName, errLine, return);
    CHECK_LINK_NUM( listNum, "FnAddTail_WasaList", errFileName, errLine, return);
    CHECK_PTR( pAddElement, "FnAddTail_WasaList", "param2", errFileName, errLine, return);
    CHECK_IN_ELEMENT( listNum, pAddElement, "FnAddTail_WasaList", "param2", errFileName, errLine, return);

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pSimpleList);
    FnSetNull_Wasa(( void**)&pListEnd);
    FnSetNull_Wasa(( void**)&pDblList);
    FnSetNull_Wasa(( void**)&pListDblEnd);
#endif

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
        pSimpleList = ( struct SIMPLE_LIST*)pAddElement;
// 񂩂 prev, next |C^폜B
//FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pSimpleList);
//ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pSimpleList + 1, size - sizeof( *pSimpleList));
DELETE_LINK_PATRS_MEMINFO( pSimpleList, size);
        // N̕tւB
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
        pListEnd = ( struct SIMPLE_LIST*)*( gppListInfoEnd_WasaList + listNum);
//CHECK_PTR_WasaDbg( *pSimpleList);
CHECK_1BYTE_WasaDbg( pSimpleList + 1, pSimpleList + 1);
//CHECK_PTR_WasaDbg( *pListEnd);
CHECK_1BYTE_WasaDbg( pListEnd + 1, pListEnd + 1);
        pSimpleList->pNext = pListEnd->pNext;
        pListEnd->pNext = pSimpleList;
        // XgGhw|C^z̍Ē`B
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
        *( gppListInfoEnd_WasaList + listNum) = pAddElement;
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
        pDblList = ( struct DOUBLE_LIST*)pAddElement;
		// 񂩂 prev, next |C^폜B
//FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pDblList);
//ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pDblList + 1, size - sizeof( *pDblList));
DELETE_LINK_PATRS_MEMINFO( pDblList, size);
        // N̕tւB
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
        pListDblEnd = ( struct DOUBLE_LIST*)*( gppListInfoEnd_WasaList + listNum);
CHECK_1BYTE_WasaDbg( pDblList + 1, pDblList + 1);
CHECK_1BYTE_WasaDbg( pListDblEnd + 1, pListDblEnd + 1);
        pDblList->pPrev = pListDblEnd->pPrev;
        pDblList->pNext = pListDblEnd;
CHECK_1BYTE_WasaDbg( pDblList->pPrev + 1, pDblList->pPrev + 1);
        pDblList->pPrev->pNext = pDblList;
        pListDblEnd->pPrev = pDblList;
        // XgGh͕ύXȂ̂ŃXgGhw|C^z̍Ē`͕KvȂB
    }else{
DEBUG_BREAKPOINT;
        goto LABEL1;
    }
    // XgvfCNgB
//CHECK_PTR_WasaDbg( *( gpNumberOfElement_WasaList + listNum));
CHECK_PTR_WasaDbg( gpNumberOfElement_WasaList, gpNumberOfElement_WasaList + listNum);
    *( gpNumberOfElement_WasaList + listNum) += 1;
// Xg̐`FbN( *( gpNumberOfElement_WasaList + listNum) 񃋁[vă`FbN)B
CHECK_LINKLIST( listNum);

LABEL1:;
/*CHECK_MEM_FLAG_ON_WasaDbg;*/
}

//////////////////////////////////////////////////////////////////////////////
// w肵ʒȗOɃXgvf}( P͎Ԃ܂)B
//////////////////////////////////////////////////////////////////////////////
// ߂l                       Xg䃁mۂłȂAfalseB
void FnInsertBefore_WasaList(
    int listNum,
    void* pLocateOfElement,     //      w肷郊Xgvf̃AhXB
    void* pInsertElement        //      mۍς݃Xgvfւ̃|C^B
#ifndef NDEBUG
	, int size,
    char* errFileName,
    int errLine
#endif
)
{
    struct SIMPLE_LIST* pPrev;
    struct SIMPLE_LIST* pCurrent;
    struct SIMPLE_LIST* pIns;
    struct SIMPLE_LIST* pLocate;
    struct DOUBLE_LIST* pInsDbl;
    struct DOUBLE_LIST* pLocateDbl;

    CHECK_INIT( "FnInsert_WasaList", errFileName, errLine, return);
    CHECK_LINK_NUM( listNum, "FnInsert_WasaList", errFileName, errLine, return);
    CHECK_PTR( pLocateOfElement, "FnInsert_WasaList", "param2", errFileName, errLine, return);
    CHECK_PTR( pInsertElement, "FnInsert_WasaList", "param3", errFileName, errLine, return);
    CHECK_ELEMENT( listNum, pLocateOfElement, "FnInsert_WasaList", "param2", errFileName, errLine, return);
    CHECK_IN_ELEMENT( listNum, pInsertElement, "FnInsert_WasaList", "param3", errFileName, errLine, return);

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pPrev);
    FnSetNull_Wasa(( void**)&pCurrent);
    FnSetNull_Wasa(( void**)&pIns);
    FnSetNull_Wasa(( void**)&pLocate);
    FnSetNull_Wasa(( void**)&pInsDbl);
    FnSetNull_Wasa(( void**)&pLocateDbl);
#endif

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
        // ÕXgvfB
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        pPrev = ( struct SIMPLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
//CHECK_PTR_WasaDbg( *pPrev);
CHECK_1BYTE_WasaDbg( pPrev + 1, pPrev + 1);
        for( pCurrent = pPrev->pNext; pCurrent != NULL; pCurrent = pCurrent->pNext){
            if( pCurrent == pLocateOfElement){
                goto LABEL1;
            }
            pPrev = pCurrent;
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
        }
#ifndef NDEBUG
        DISP_ERR_STRING_WasaDbg( "FnInsert_WasaList( param2): w肳ꂽXgvf݂܂B", errFileName, errLine);
#else
        DISP_ERR_STRING_WasaDbg( "FnInsert_WasaList( param2): w肳ꂽXgvf݂܂B", __FILE__, __LINE__);
#endif
        return;

        LABEL1:
        pIns = ( struct SIMPLE_LIST*)pInsertElement;
        pLocate = ( struct SIMPLE_LIST*)pLocateOfElement;
        // N̕tւB
//CHECK_PTR_WasaDbg( *pIns);
CHECK_1BYTE_WasaDbg( pIns + 1, pIns + 1);
        pIns->pNext = pLocate;
//CHECK_PTR_WasaDbg( *pPrev);
CHECK_1BYTE_WasaDbg( pPrev + 1, pPrev + 1);
        pPrev->pNext = pIns;
        // XgI[ɑ}Ȃ̂ŁAXgGhw|C^z̍Ē`͕KvȂB
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
        pInsDbl = ( struct DOUBLE_LIST*)pInsertElement;
        pLocateDbl = ( struct DOUBLE_LIST*)pLocateOfElement;
// 񂩂 prev, next |C^폜B
//FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pInsDbl);
//ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pInsDbl + 1, size - sizeof( *pInsDbl));
DELETE_LINK_PATRS_MEMINFO( pInsDbl, size);
        // N̕tւB
CHECK_1BYTE_WasaDbg( pInsDbl + 1, pInsDbl + 1);
CHECK_1BYTE_WasaDbg( pLocateDbl + 1, pLocateDbl + 1);
        pInsDbl->pPrev = pLocateDbl->pPrev;
        pInsDbl->pNext = pLocateDbl;
        pLocateDbl->pPrev = pInsDbl;
CHECK_1BYTE_WasaDbg( pInsDbl->pPrev + 1, pInsDbl->pPrev + 1);
        pInsDbl->pPrev->pNext = pInsDbl;
    }else{
        DEBUG_BREAKPOINT;
        return;
    }
    // XgvfCNgB
//CHECK_PTR_WasaDbg( *( gpNumberOfElement_WasaList + listNum));
CHECK_PTR_WasaDbg( gpNumberOfElement_WasaList, gpNumberOfElement_WasaList + listNum);
    *( gpNumberOfElement_WasaList + listNum) += 1;
    // Xg̐`FbN( *( gpNumberOfElement_WasaList + listNum) 񃋁[vă`FbN)B
    CHECK_LINKLIST( listNum);
}

//////////////////////////////////////////////////////////////////////////////
// w肵ʒu̎ɃXgvf}B
//////////////////////////////////////////////////////////////////////////////
void FnInsertAfter_WasaList(
    int listNum,
    void* pLocateOfElement,     //      w肷郊Xgvf̃AhXB
    void* pInsertElement        //      mۍς݃Xgvfւ̃|C^B
#ifndef NDEBUG
	, int size,
    char* errFileName,
    int errLine
#endif
)
{
    struct SIMPLE_LIST* pIns;
    struct SIMPLE_LIST* pLocate;
    struct DOUBLE_LIST* pInsDbl;
    struct DOUBLE_LIST* pLocateDbl;

    CHECK_INIT( "FnInsertAfter_WasaList", errFileName, errLine, return);
    CHECK_LINK_NUM( listNum, "FnInsertAfter_WasaList", errFileName, errLine, return);
    CHECK_PTR( pLocateOfElement, "FnInsertAfter_WasaList", "param2", errFileName, errLine, return);
    CHECK_PTR( pInsertElement, "FnInsertAfter_WasaList", "param3", errFileName, errLine, return);
    CHECK_ELEMENT( listNum, pLocateOfElement, "FnInsertAfter_WasaList", "param2", errFileName, errLine, return);
    CHECK_IN_ELEMENT( listNum, pInsertElement, "FnInsertAfter_WasaList", "param3", errFileName, errLine, return);

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pIns);
    FnSetNull_Wasa(( void**)&pLocate);
    FnSetNull_Wasa(( void**)&pInsDbl);
    FnSetNull_Wasa(( void**)&pLocateDbl);
#endif

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
        pIns = ( struct SIMPLE_LIST*)pInsertElement;
        pLocate = ( struct SIMPLE_LIST*)pLocateOfElement;
        // N̕tւB
//CHECK_PTR_WasaDbg( *pIns);
CHECK_1BYTE_WasaDbg( pIns + 1, pIns + 1);
//CHECK_PTR_WasaDbg( *pLocate);
CHECK_1BYTE_WasaDbg( pLocate + 1, pLocate + 1);
        pIns->pNext = pLocate->pNext;
        pLocate->pNext = pIns;
        // XgI[ɑ}鎞AXgGhw|C^z̍Ē`B
        if( pIns->pNext == NULL){
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
            *( gppListInfoEnd_WasaList + listNum) = pInsertElement;
        }
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
        pInsDbl = ( struct DOUBLE_LIST*)pInsertElement;
        pLocateDbl = ( struct DOUBLE_LIST*)pLocateOfElement;
// 񂩂 prev, next |C^폜B
//FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pInsDbl);
//ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pInsDbl + 1, size - sizeof( *pInsDbl));
DELETE_LINK_PATRS_MEMINFO( pInsDbl, size);
        // N̕tւB
CHECK_1BYTE_WasaDbg( pInsDbl + 1, pInsDbl + 1);
        pInsDbl->pPrev = pLocateDbl;
CHECK_1BYTE_WasaDbg( pLocateDbl + 1, pLocateDbl + 1);
        pInsDbl->pNext = pLocateDbl->pNext;
CHECK_1BYTE_WasaDbg( pInsDbl->pNext + 1, pInsDbl->pNext + 1);
        pInsDbl->pNext->pPrev = pInsDbl;
        pLocateDbl->pNext = pInsDbl;
    }else{
        DEBUG_BREAKPOINT;
        return;
    }
    // XgvfCNgB
//CHECK_PTR_WasaDbg( *( gpNumberOfElement_WasaList + listNum));
CHECK_PTR_WasaDbg( gpNumberOfElement_WasaList, gpNumberOfElement_WasaList + listNum);
    *( gpNumberOfElement_WasaList + listNum) += 1;
    // Xg̐`FbN( *( gpNumberOfElement_WasaList + listNum) 񃋁[vă`FbN)B
    CHECK_LINKLIST( listNum);
}

//////////////////////////////////////////////////////////////////////////////
// 擪Xgvfւ̃|C^擾B
//////////////////////////////////////////////////////////////////////////////
// ߂l                       XgvfAfalseB
int FnGetHead_WasaList(
    int listNum,
    void** ppGetElement // o     擾擪Xgvfւ̃|C^( *ppGetElement)BXgvf *ppGetElement == NULLB
                        //          (擾|C^ɏގ́A_WasaDbg.h  CHECK_PTR_WasaDbg Ń`FbN)
#ifndef NDEBUG
	, int size,				// ́@@vfTCY
    char* errFileName,
    int errLine
#endif
)
{
/*CHECK_MEM_FLAG_OFF_WasaDbg;*/

    int result = true;
    struct SIMPLE_LIST* pListHeader;
    struct DOUBLE_LIST* pListDblHeader;

    CHECK_INIT( "FnGetHead_WasaList", errFileName, errLine, return( false));
    CHECK_LINK_NUM( listNum, "FnGetHead_WasaList", errFileName, errLine, return( false));
    CHECK_DBLPTR( ppGetElement, "FnGetHead_WasaList", "param2", errFileName, errLine, return( false));

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pListHeader);
    FnSetNull_Wasa(( void**)&pListDblHeader);
#endif

//CHECK_PTR_WasaDbg( *ppGetElement);
CHECK_PTR_WasaDbg( ppGetElement, ppGetElement);

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        pListHeader = ( struct SIMPLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
//CHECK_PTR_WasaDbg( *pListHeader);
CHECK_1BYTE_WasaDbg( pListHeader + 1, pListHeader + 1);
        if( pListHeader->pNext == NULL){
            *ppGetElement = NULL;
            result = false;
            goto LABEL1;
        }
        *ppGetElement = pListHeader->pNext;
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        pListDblHeader = ( struct DOUBLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
CHECK_1BYTE_WasaDbg( pListDblHeader + 1, pListDblHeader + 1);
CHECK_1BYTE_WasaDbg( pListDblHeader->pNext + 1, pListDblHeader->pNext + 1);
        if( pListDblHeader->pNext->pNext == NULL){
            *ppGetElement = NULL;
            result = false;
            goto LABEL1;
        }
        *ppGetElement = pListDblHeader->pNext;
    }else{
		exit( -1);
    }
CHECK_ELEMENT_WITH_SIZE_WasaDbg( listNum, *ppGetElement, size);

LABEL1:
/*CHECK_MEM_FLAG_ON_WasaDbg;*/
    return( result);
}

//////////////////////////////////////////////////////////////////////////////
// I[Xgvfւ̃|C^擾B
//////////////////////////////////////////////////////////////////////////////
// ߂l                       XgvfAfalseB
int FnGetTail_WasaList(
    int listNum,
    void** ppGetElement // o     擾I[Xgvfւ̃|C^( *ppGetElement)BvfA*ppGetElement == NULLB
                        //          (擾|C^ɏގ́A_WasaDbg.h  CHECK_PTR_WasaDbg Ń`FbN)
#ifndef NDEBUG
	, int size,				// ́@@vfTCY
    char* errFileName,
    int errLine
#endif
)
{
/*CHECK_MEM_FLAG_OFF_WasaDbg;*/

    int result = true;
    struct SIMPLE_LIST* pListEnd;
    struct DOUBLE_LIST* pListDblEnd;

    CHECK_INIT( "FnGetTail_WasaList", errFileName, errLine, return( false));
    CHECK_LINK_NUM( listNum, "FnGetTail_WasaList", errFileName, errLine, return( false));
    CHECK_DBLPTR( ppGetElement, "FnGetTail_WasaList", "param2", errFileName, errLine, return( false));

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pListEnd);
    FnSetNull_Wasa(( void**)&pListDblEnd);
#endif

//CHECK_PTR_WasaDbg( *ppGetElement);
CHECK_PTR_WasaDbg( ppGetElement, ppGetElement);

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
        pListEnd = ( struct SIMPLE_LIST*)*( gppListInfoEnd_WasaList + listNum);
/*CHECK_1BYTE_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);*/
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        if( pListEnd == *( gppListInfoHeader_WasaList + listNum)){
            *ppGetElement = NULL;
            result = false;
            goto LABEL1;
        }
        *ppGetElement = pListEnd;
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
        pListDblEnd = ( struct DOUBLE_LIST*)*( gppListInfoEnd_WasaList + listNum);
CHECK_1BYTE_WasaDbg( pListDblEnd + 1, pListDblEnd + 1);
CHECK_1BYTE_WasaDbg( pListDblEnd->pPrev + 1, pListDblEnd->pPrev + 1);
        if( pListDblEnd->pPrev->pPrev == NULL){
            *ppGetElement = NULL;
            result = false;
            goto LABEL1;
        }
        *ppGetElement = pListDblEnd->pPrev;
    }else{
		exit( -1);
    }
CHECK_ELEMENT_WITH_SIZE_WasaDbg( listNum, *ppGetElement, size);

LABEL1:
//#ifndef NDEBUG
//	if( NULL != *ppGetElement){
//		CHECK_MEM_WasaDbg( *ppGetElement, *ppGetElement, size);
//	}
//#endif

// Xg̐`FbN( *( gpNumberOfElement_WasaList + listNum) 񃋁[vă`FbN)B
CHECK_LINKLIST( listNum);

/*CHECK_MEM_FLAG_ON_WasaDbg;*/
    return( result);
}

//////////////////////////////////////////////////////////////////////////////
// ÕXgvfւ̃|C^擾( P͎Ԃ܂)B
//////////////////////////////////////////////////////////////////////////////
// ߂l                           ÕXgvf݂ȂA܂́AXgwb_̎AfalseB
int FnGetPrev_WasaList(
    int listNum,
    void* pLocateOfElement, //     w肷郊Xgvf̃AhXB
    void** ppGetElement     // o    ÕXgvfւ̃|C^( *ppGetElement)B
                            //     ÕXgvf݂ȂA*ppGetElement == NULLB
                            //     (擾|C^ɏގ́A_WasaDbg.h  CHECK_PTR_WasaDbg Ń`FbN)
#ifndef NDEBUG
	, int size,				// ́@@vfTCY
    char* errFileName,
    int errLine
#endif
)
{
/*CHECK_MEM_FLAG_OFF_WasaDbg;*/

    int result = true;
    struct SIMPLE_LIST* pLinkHeader;
    struct SIMPLE_LIST* pPrev;
    struct SIMPLE_LIST* pCurrent;
	void* pTmp;

    CHECK_INIT( "FnGetPrev_WasaList", errFileName, errLine, return( false));
    CHECK_LINK_NUM( listNum, "FnGetPrev_WasaList", errFileName, errLine, return( false));
    CHECK_PTR( pLocateOfElement, "FnGetPrev_WasaList", "param2", errFileName, errLine, return( false));
#ifndef NDEBUG
//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
	if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList && pLocateOfElement == *( gppListInfoEnd_WasaList + listNum)){
		// dummy
	}else{
    	CHECK_ELEMENT( listNum, pLocateOfElement, "FnGetPrev_WasaList", "param2", errFileName, errLine, return( false));
	}
#endif
    CHECK_DBLPTR( ppGetElement, "FnGetPrev_WasaList", "param3", errFileName, errLine, return( false));

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pLinkHeader);
    FnSetNull_Wasa(( void**)&pPrev);
    FnSetNull_Wasa(( void**)&pCurrent);
#endif

//CHECK_PTR_WasaDbg( *ppGetElement);
CHECK_PTR_WasaDbg( ppGetElement, ppGetElement);

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        pLinkHeader = ( struct SIMPLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
		pPrev = NULL;
		for( pCurrent = pLinkHeader; pCurrent != NULL; pCurrent = pCurrent->pNext){
            if( pCurrent == pLocateOfElement){
                if( pPrev == pLinkHeader || pPrev == NULL){
                    *ppGetElement = NULL;
                    result = false;
					goto LABEL_END;
				}
                goto LABEL1;
            }
            pPrev = pCurrent;
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
        }
        // CHECK_ELEMENT() ŃXgvfł邱Ƃۏ؂Ă̂ŁAʂ̂͂B
		exit( -1);

LABEL1:
        *ppGetElement = pPrev;
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
CHECK_1BYTE_WasaDbg(( struct DOUBLE_LIST*)pLocateOfElement + 1, ( struct DOUBLE_LIST*)pLocateOfElement + 1);
		pTmp = (( struct DOUBLE_LIST*)pLocateOfElement)->pPrev;
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        if( pTmp == *( gppListInfoHeader_WasaList + listNum) || pTmp == NULL){
            *ppGetElement = NULL;
            result = false;
			goto LABEL_END;
        }
        *ppGetElement = pTmp;
    }else{
		exit( -1);
    }
CHECK_ELEMENT_WITH_SIZE_WasaDbg( listNum, *ppGetElement, size);

//#ifndef NDEBUG
//	if( NULL != *ppGetElement){
//		CHECK_MEM_WasaDbg( *ppGetElement, *ppGetElement, size);
//	}
//#endif

LABEL_END:
/*CHECK_MEM_FLAG_ON_WasaDbg;*/
    return( result);
}

//////////////////////////////////////////////////////////////////////////////
// ̃Xgvfւ̃|C^擾B
//////////////////////////////////////////////////////////////////////////////
// ߂l                           ̃Xgvf݂ȂA܂́AõXgGh̎AfalseB
int FnGetNext_WasaList(
    int listNum,
    void* pLocateOfElement, //     w肷郊Xgvf̃AhXB
    void** ppGetElement     // o    ̃Xgvfւ̃|C^( *ppGetElement)B
                            //     	̃Xgvf݂ȂA*ppGetElement == NULLB
                            //     (擾|C^ɏގ́A_WasaDbg.h  CHECK_PTR_WasaDbg Ń`FbN)
#ifndef NDEBUG
	, int size,				// ́@@vfTCY
    char* errFileName,
    int errLine
#endif
)
{
/*CHECK_MEM_FLAG_OFF_WasaDbg;*/

    int result = true;
	void* pTmp;

    CHECK_INIT( "FnGetNext_WasaList", errFileName, errLine, return( false));
    CHECK_LINK_NUM( listNum, "FnGetNext_WasaList", errFileName, errLine, return( false));
    CHECK_PTR( pLocateOfElement, "FnGetNext_WasaList", "param2", errFileName, errLine, return( false));
#ifndef NDEBUG
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
	if( pLocateOfElement != *( gppListInfoHeader_WasaList + listNum)){
    	CHECK_ELEMENT( listNum, pLocateOfElement, "FnGetNext_WasaList", "param2", errFileName, errLine, return( false));
	}
#endif
    CHECK_DBLPTR( ppGetElement, "FnGetNext_WasaList", "param3", errFileName, errLine, return( false));
//CHECK_PTR_WasaDbg( *ppGetElement);
CHECK_PTR_WasaDbg( ppGetElement, ppGetElement);

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
CHECK_1BYTE_WasaDbg(( struct SIMPLE_LIST*)pLocateOfElement + 1, ( struct SIMPLE_LIST*)pLocateOfElement + 1);
		pTmp = (( struct SIMPLE_LIST*)pLocateOfElement)->pNext;
        if( pTmp == NULL){
			*ppGetElement = NULL;
            result = false;
			goto LABEL_END;
        }
        *ppGetElement = pTmp;
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
CHECK_1BYTE_WasaDbg(( struct DOUBLE_LIST*)pLocateOfElement + 1, ( struct DOUBLE_LIST*)pLocateOfElement + 1);
		pTmp = (( struct DOUBLE_LIST*)pLocateOfElement)->pNext;
        *ppGetElement = pTmp;
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
        if( pTmp == *( gppListInfoEnd_WasaList + listNum) ||
		pTmp == NULL){
            *ppGetElement = NULL;
            result = false;
			goto LABEL_END;
        }
    }else{
		exit( -1);
    }
CHECK_ELEMENT_WITH_SIZE_WasaDbg( listNum, *ppGetElement, size);

LABEL_END:
//#ifndef NDEBUG
//	if( NULL != *ppGetElement){
//		CHECK_MEM_WasaDbg( *ppGetElement, *ppGetElement, size);
//	}
//#endif

/*CHECK_MEM_FLAG_ON_WasaDbg;*/
    return( result);
}

//////////////////////////////////////////////////////////////////////////////
// 擪Xgvf폜B
//////////////////////////////////////////////////////////////////////////////
// ߂l                   Xgvf݂ȂAfalseB
int FnRemoveHead_WasaList(
    int listNum
#ifndef NDEBUG
    , char* errFileName,
    int errLine
#endif
)
{
/*CHECK_MEM_FLAG_OFF_WasaDbg;*/

    int result = true;
    struct SIMPLE_LIST* pHeader;
    struct SIMPLE_LIST* pCurrent;
    struct DOUBLE_LIST* pHeaderDbl;
    struct DOUBLE_LIST* pCurrentDbl;

    CHECK_INIT( "FnRemoveHead_WasaList", errFileName, errLine, return( false));
    CHECK_LINK_NUM( listNum, "FnRemoveHead_WasaList", errFileName, errLine, return( false));

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pHeader);
    FnSetNull_Wasa(( void**)&pCurrent);
    FnSetNull_Wasa(( void**)&pHeaderDbl);
    FnSetNull_Wasa(( void**)&pCurrentDbl);
#endif

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        pHeader = ( struct SIMPLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
//CHECK_PTR_WasaDbg( *pHeader);
CHECK_1BYTE_WasaDbg( pHeader + 1, pHeader + 1);
        pCurrent = pHeader->pNext;
        if( pCurrent == NULL){
            result = false;
            goto LABEL1;
        }
        // N̕tւB
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
        pHeader->pNext = pCurrent->pNext;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrent + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrent, 1);
        // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + listNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + listNum);
        ( *( gppFreeElementFunc_WasaList + listNum))( pCurrent);
        // XgvfȂȂAXgGhύXB
        if( pHeader->pNext == NULL){
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
            *( gppListInfoEnd_WasaList + listNum) = pHeader;
        }
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        pHeaderDbl = ( struct DOUBLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
CHECK_1BYTE_WasaDbg( pHeaderDbl + 1, pHeaderDbl + 1);
        pCurrentDbl = pHeaderDbl->pNext;
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1);
        if( pCurrentDbl->pNext == NULL){
            result = false;
            goto LABEL1;
        }
        // N̕tւB
        pHeaderDbl->pNext = pCurrentDbl->pNext;
CHECK_1BYTE_WasaDbg( pCurrentDbl->pNext + 1, pCurrentDbl->pNext + 1);
        pCurrentDbl->pNext->pPrev = pHeaderDbl;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl, 1);
        // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + listNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + listNum);
        ( *( gppFreeElementFunc_WasaList + listNum))( pCurrentDbl);
    }else{
        DEBUG_BREAKPOINT;
        result = false;
        goto LABEL1;
    }
//CHECK_PTR_WasaDbg( *( gpNumberOfElement_WasaList + listNum));
CHECK_PTR_WasaDbg( gpNumberOfElement_WasaList, gpNumberOfElement_WasaList + listNum);
    *( gpNumberOfElement_WasaList + listNum) -= 1;

LABEL1:
// Xg̐`FbN( *( gpNumberOfElement_WasaList + listNum) 񃋁[vă`FbN)B
CHECK_LINKLIST( listNum);
/*CHECK_MEM_FLAG_ON_WasaDbg;*/
    return( result);
}

//////////////////////////////////////////////////////////////////////////////
// I[Xgvf폜( P͎Ԃ܂)B
//////////////////////////////////////////////////////////////////////////////
// ߂l                   Xgvf݂ȂAfalseB
int FnRemoveTail_WasaList(
    int listNum
#ifndef NDEBUG
    , char* errFileName,
    int errLine
#endif
)
{
/*CHECK_MEM_FLAG_OFF_WasaDbg;*/

    int result = true;
    struct SIMPLE_LIST* pHeader;
    struct SIMPLE_LIST* pEnd;
    struct SIMPLE_LIST* pPrev;
    struct SIMPLE_LIST* pCurrent;
    struct DOUBLE_LIST* pEndDbl;
    struct DOUBLE_LIST* pCurrentDbl;

    CHECK_INIT( "FnRemoveTail_WasaList", errFileName, errLine, return( false));
    CHECK_LINK_NUM( listNum, "FnRemoveTail_WasaList", errFileName, errLine, return( false));

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pHeader);
    FnSetNull_Wasa(( void**)&pEnd);
    FnSetNull_Wasa(( void**)&pPrev);
    FnSetNull_Wasa(( void**)&pCurrent);
    FnSetNull_Wasa(( void**)&pEndDbl);
    FnSetNull_Wasa(( void**)&pCurrentDbl);
#endif

CHECK_LINKLIST( listNum);

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        pHeader = ( struct SIMPLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
        pEnd = ( struct SIMPLE_LIST*)*( gppListInfoEnd_WasaList + listNum);
        if( pHeader == pEnd){
            result = false;
            goto LABEL1;
        }
        pPrev = pHeader;
//CHECK_PTR_WasaDbg( *pHeader);
CHECK_1BYTE_WasaDbg( pHeader + 1, pHeader + 1);
        for( pCurrent = pHeader->pNext; pCurrent != pEnd; pCurrent = pCurrent->pNext){
            pPrev = pCurrent;
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
        }
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
        assert( pCurrent->pNext == NULL);
        // N̕tւB
//CHECK_PTR_WasaDbg( *pPrev);
CHECK_1BYTE_WasaDbg( pPrev + 1, pPrev + 1);
        pPrev->pNext = NULL;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrent + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrent, 1);
        // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + listNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + listNum);
        ( *( gppFreeElementFunc_WasaList + listNum))( pCurrent);
        // XgGhύXB
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
        *( gppListInfoEnd_WasaList + listNum) = pPrev;
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
        pEndDbl = ( struct DOUBLE_LIST*)*( gppListInfoEnd_WasaList + listNum);
CHECK_1BYTE_WasaDbg( pEndDbl + 1, pEndDbl + 1);
        pCurrentDbl = pEndDbl->pPrev;
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1);
        if( pCurrentDbl->pPrev == NULL){
            result = false;
            goto LABEL1;
        }
        // N̕tւB
CHECK_1BYTE_WasaDbg( pCurrentDbl->pPrev + 1, pCurrentDbl->pPrev + 1);
        pCurrentDbl->pPrev->pNext = pEndDbl;
        pEndDbl->pPrev = pCurrentDbl->pPrev;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl, 1);
        // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + listNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + listNum);
        ( *( gppFreeElementFunc_WasaList + listNum))( pCurrentDbl);
    }else{
        DEBUG_BREAKPOINT;
        result = false;
        goto LABEL1;
    }
//CHECK_PTR_WasaDbg( *( gpNumberOfElement_WasaList + listNum));
CHECK_PTR_WasaDbg( gpNumberOfElement_WasaList, gpNumberOfElement_WasaList + listNum);
    *( gpNumberOfElement_WasaList + listNum) -= 1;

LABEL1:
// Xg̐`FbN( *( gpNumberOfElement_WasaList + listNum) 񃋁[vă`FbN)B
CHECK_LINKLIST( listNum);
/*CHECK_MEM_FLAG_ON_WasaDbg;*/
    return( result);
}

//////////////////////////////////////////////////////////////////////////////
// w肵ʒȗÕXgvf폜( P͎Ԃ܂)B
//////////////////////////////////////////////////////////////////////////////
// ߂l                   ÕXgvf݂ȂAfalseB
int FnRemovePrev_WasaList(
    int listNum,
    void* pLocateOfElement  //     w肷郊Xgvf̃AhXB
#ifndef NDEBUG
    , char* errFileName,
    int errLine
#endif
)
{
/*CHECK_MEM_FLAG_OFF_WasaDbg;*/

    int result = true;
    struct SIMPLE_LIST* pHeader;
    struct SIMPLE_LIST* pPrevPrev;
    struct SIMPLE_LIST* pPrev;
    struct SIMPLE_LIST* pCurrent;
    struct DOUBLE_LIST* pElementDbl;
    struct DOUBLE_LIST* pCurrentDbl;

    CHECK_INIT( "FnRemovePrev_WasaList", errFileName, errLine, return( false));
    CHECK_LINK_NUM( listNum, "FnRemovePrev_WasaList", errFileName, errLine, return( false));
    CHECK_PTR( pLocateOfElement, "FnRemovePrev_WasaList", "param2", errFileName, errLine, return( false));
    CHECK_ELEMENT( listNum, pLocateOfElement, "FnRemovePrev_WasaList", "param2", errFileName, errLine, return( false));

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pHeader);
    FnSetNull_Wasa(( void**)&pPrevPrev);
    FnSetNull_Wasa(( void**)&pPrev);
    FnSetNull_Wasa(( void**)&pCurrent);
    FnSetNull_Wasa(( void**)&pElementDbl);
    FnSetNull_Wasa(( void**)&pCurrentDbl);
#endif

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        pHeader = ( struct SIMPLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
        pPrevPrev = pHeader;
//CHECK_PTR_WasaDbg( *pHeader);
CHECK_1BYTE_WasaDbg( pHeader + 1, pHeader + 1);
        pPrev = pHeader->pNext;
        if( pPrev == pLocateOfElement){
            result = false;
            goto LABEL1;
        }
//CHECK_PTR_WasaDbg( *pPrev);
CHECK_1BYTE_WasaDbg( pPrev + 1, pPrev + 1);
        for( pCurrent = pPrev->pNext; pCurrent != pLocateOfElement; pCurrent = pCurrent->pNext){
            pPrevPrev = pPrev;
            pPrev = pCurrent;
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
        }
        assert( pCurrent == pLocateOfElement);
        // N̕tւB
//CHECK_PTR_WasaDbg( *pPrevPrev);
CHECK_1BYTE_WasaDbg( pPrevPrev + 1, pPrevPrev + 1);
//CHECK_PTR_WasaDbg( *pPrev);
CHECK_1BYTE_WasaDbg( pPrev + 1, pPrev + 1);
        pPrevPrev->pNext = pPrev->pNext;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pPrev + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pPrev, 1);
        // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + listNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + listNum);
        ( *( gppFreeElementFunc_WasaList + listNum))( pPrev);
        // XgI[vf͊JȂ̂ŃXgGhύXKvȂB
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
        pElementDbl = ( struct DOUBLE_LIST*)pLocateOfElement;
CHECK_1BYTE_WasaDbg( pElementDbl + 1, pElementDbl + 1);
        pCurrentDbl = pElementDbl->pPrev;
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1);
        if( pCurrentDbl->pPrev == NULL){
            result = false;
            goto LABEL1;
        }
        // N̕tւB
CHECK_1BYTE_WasaDbg( pCurrentDbl->pPrev + 1, pCurrentDbl->pPrev + 1);
        pCurrentDbl->pPrev->pNext = pElementDbl;
        pElementDbl->pPrev = pCurrentDbl->pPrev;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl, 1);
        // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + listNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + listNum);
        ( *( gppFreeElementFunc_WasaList + listNum))( pCurrentDbl);
    }else{
        DEBUG_BREAKPOINT;
        result = false;
        goto LABEL1;
    }
//CHECK_PTR_WasaDbg( *( gpNumberOfElement_WasaList + listNum));
CHECK_PTR_WasaDbg( gpNumberOfElement_WasaList, gpNumberOfElement_WasaList + listNum);
    *( gpNumberOfElement_WasaList + listNum) -= 1;
    
LABEL1:
// Xg̐`FbN( *( gpNumberOfElement_WasaList + listNum) 񃋁[vă`FbN)B
CHECK_LINKLIST( listNum);
/*CHECK_MEM_FLAG_ON_WasaDbg;*/
    return( result);
}

//////////////////////////////////////////////////////////////////////////////
// w肵ʒũXgvf폜( P͎Ԃ܂)B
//////////////////////////////////////////////////////////////////////////////
void FnRemoveAt_WasaList(
    int listNum,
    void* pLocateOfElement  //     w肷郊Xgvf̃AhXB
#ifndef NDEBUG
    , char* errFileName,
    int errLine
#endif
)
{
    struct SIMPLE_LIST* pHeader;
    struct SIMPLE_LIST* pPrev;
    struct SIMPLE_LIST* pCurrent;
    struct DOUBLE_LIST* pCurrentDbl;

    CHECK_INIT( "FnRemoveAt_WasaList", errFileName, errLine, return);
    CHECK_LINK_NUM( listNum, "FnRemoveAt_WasaList", errFileName, errLine, return);
    CHECK_PTR( pLocateOfElement, "FnRemoveAt_WasaList", "param2", errFileName, errLine, return);
    CHECK_ELEMENT( listNum, pLocateOfElement, "FnRemoveAt_WasaList", "param2", errFileName, errLine, return);

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pHeader);
    FnSetNull_Wasa(( void**)&pPrev);
    FnSetNull_Wasa(( void**)&pCurrent);
    FnSetNull_Wasa(( void**)&pCurrentDbl);
#endif

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        pHeader = ( struct SIMPLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
        pPrev = pHeader;
//CHECK_PTR_WasaDbg( *pPrev);
CHECK_1BYTE_WasaDbg( pPrev + 1, pPrev + 1);
        for( pCurrent = pPrev->pNext; pCurrent != pLocateOfElement; pCurrent = pCurrent->pNext){
            pPrev = pCurrent;
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
        }
        assert( pCurrent == pLocateOfElement);
        // N̕tւB
//CHECK_PTR_WasaDbg( *pPrev);
CHECK_1BYTE_WasaDbg( pPrev + 1, pPrev + 1);
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
        pPrev->pNext = pCurrent->pNext;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrent + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrent, 1);
        // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + listNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + listNum);
        ( *( gppFreeElementFunc_WasaList + listNum))( pCurrent);
        // XgI[vfJAXgGhύXB
//CHECK_PTR_WasaDbg( *pPrev);
CHECK_1BYTE_WasaDbg( pPrev + 1, pPrev + 1);
        if( pPrev->pNext == NULL){
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
            *( gppListInfoEnd_WasaList + listNum) = pPrev;
        }
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){

// Xg̐`FbN( *( gpNumberOfElement_WasaList + listNum) 񃋁[vă`FbN)B
CHECK_LINKLIST( listNum);

        pCurrentDbl = ( struct DOUBLE_LIST*)pLocateOfElement;
        // N̕tւB
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1);
CHECK_1BYTE_WasaDbg( pCurrentDbl->pPrev + 1, pCurrentDbl->pPrev + 1);
        pCurrentDbl->pPrev->pNext = pCurrentDbl->pNext;
CHECK_1BYTE_WasaDbg( pCurrentDbl->pNext + 1, pCurrentDbl->pNext + 1);
        pCurrentDbl->pNext->pPrev = pCurrentDbl->pPrev;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl, 1);
        // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + listNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + listNum);
        ( *( gppFreeElementFunc_WasaList + listNum))( pCurrentDbl);
    }else{
        DEBUG_BREAKPOINT;
        return;
    }
//CHECK_PTR_WasaDbg( *( gpNumberOfElement_WasaList + listNum));
CHECK_PTR_WasaDbg( gpNumberOfElement_WasaList, gpNumberOfElement_WasaList + listNum);
    *( gpNumberOfElement_WasaList + listNum) -= 1;
// Xg̐`FbN( *( gpNumberOfElement_WasaList + listNum) 񃋁[vă`FbN)B
CHECK_LINKLIST( listNum);
}

//////////////////////////////////////////////////////////////////////////////
// w肵ʒu̎̃Xgvf폜B
//////////////////////////////////////////////////////////////////////////////
// ߂l                   ̃Xgvf݂ȂAfalseB
int FnRemoveNext_WasaList(
    int listNum,
    void* pLocateOfElement  //     w肷郊Xgvf̃AhXB
#ifndef NDEBUG
    , char* errFileName,
    int errLine
#endif
)
{
    int result = true;
    struct SIMPLE_LIST* pCurrent;
    struct SIMPLE_LIST* pNext;
    struct DOUBLE_LIST* pCurrentDbl;
    struct DOUBLE_LIST* pNextDbl;

    CHECK_INIT( "FnRemoveNext_WasaList", errFileName, errLine, return( false));
    CHECK_LINK_NUM( listNum, "FnRemoveNext_WasaList", errFileName, errLine, return( false));
    CHECK_PTR( pLocateOfElement, "FnRemoveNext_WasaList", "param2", errFileName, errLine, return( false));
    CHECK_ELEMENT( listNum, pLocateOfElement, "FnRemoveNext_WasaList", "param2", errFileName, errLine, return( false));

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pCurrent);
    FnSetNull_Wasa(( void**)&pNext);
    FnSetNull_Wasa(( void**)&pCurrentDbl);
    FnSetNull_Wasa(( void**)&pNextDbl);
#endif

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
        pCurrent = ( struct SIMPLE_LIST*)pLocateOfElement;
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
        pNext = pCurrent->pNext;
        if( pNext == NULL){
            result = false;
            goto LABEL1;
        }
        // N̕tւB
//CHECK_PTR_WasaDbg( *pNext);
CHECK_1BYTE_WasaDbg( pNext + 1, pNext + 1);
        pCurrent->pNext = pNext->pNext;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pNext + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pNext, 1);
        // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + listNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + listNum);
        ( *( gppFreeElementFunc_WasaList + listNum))( pNext);
        // XgI[vfJAXgGhύXB
        if( pCurrent->pNext == NULL){
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
            *( gppListInfoEnd_WasaList + listNum) = pCurrent;
        }
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
        pCurrentDbl = ( struct DOUBLE_LIST*)pLocateOfElement;
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1);
        pNextDbl = pCurrentDbl->pNext;
CHECK_1BYTE_WasaDbg( pNextDbl + 1, pNextDbl + 1);
        if( pNextDbl->pNext == NULL){
            result = false;
            goto LABEL1;
        }
        // N̕tւB
        pCurrentDbl->pNext = pNextDbl->pNext;
CHECK_1BYTE_WasaDbg( pNextDbl->pNext + 1, pNextDbl->pNext + 1);
        pNextDbl->pNext->pPrev = pCurrentDbl;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pNextDbl + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pNextDbl, 1);
        // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + listNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + listNum);
        ( *( gppFreeElementFunc_WasaList + listNum))( pNextDbl);
    }else{
        DEBUG_BREAKPOINT;
        return( false);
    }
//CHECK_PTR_WasaDbg( *( gpNumberOfElement_WasaList + listNum));
CHECK_PTR_WasaDbg( gpNumberOfElement_WasaList, gpNumberOfElement_WasaList + listNum);
    *( gpNumberOfElement_WasaList + listNum) -= 1;
    
LABEL1:
// Xg̐`FbN( *( gpNumberOfElement_WasaList + listNum) 񃋁[vă`FbN)B
CHECK_LINKLIST( listNum);
    return( result);
}

//////////////////////////////////////////////////////////////////////////////
// SẴXgvf폜B
//////////////////////////////////////////////////////////////////////////////
void FnRemoveAll_WasaList(
    int listNum
#ifndef NDEBUG
    , char* errFileName,
    int errLine
#endif
)
{
    struct SIMPLE_LIST* pHeader;
    struct SIMPLE_LIST* pCurrent;
    struct SIMPLE_LIST* pNext;
    struct DOUBLE_LIST* pHeaderDbl;
    struct DOUBLE_LIST* pCurrentDbl;
    struct DOUBLE_LIST* pNextDbl;
    struct DOUBLE_LIST* pEndDbl;

    CHECK_INIT( "FnRemoveAll_WasaList", errFileName, errLine, return);
    CHECK_LINK_NUM( listNum, "FnRemoveAll_WasaList", errFileName, errLine, return);

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pHeader);
    FnSetNull_Wasa(( void**)&pCurrent);
    FnSetNull_Wasa(( void**)&pNext);
    FnSetNull_Wasa(( void**)&pHeaderDbl);
    FnSetNull_Wasa(( void**)&pCurrentDbl);
    FnSetNull_Wasa(( void**)&pNextDbl);
    FnSetNull_Wasa(( void**)&pEndDbl);
#endif

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        pHeader = ( struct SIMPLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
//CHECK_PTR_WasaDbg( *pHeader);
CHECK_1BYTE_WasaDbg( pHeader + 1, pHeader + 1);
        for( pCurrent = pHeader->pNext; pCurrent != NULL; pCurrent = pNext){
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
            pNext = pCurrent->pNext;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrent + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrent, 1);
            // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + listNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + listNum);
            ( *( gppFreeElementFunc_WasaList + listNum))( pCurrent);
        }
        // Xgwb_[̐ݒB
        pHeader->pNext = NULL;
        // XgGhXgwb_[w悤ɂB
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
        *( gppListInfoEnd_WasaList + listNum) = pHeader;
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        pHeaderDbl = ( struct DOUBLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
        pEndDbl = ( struct DOUBLE_LIST*)*( gppListInfoEnd_WasaList + listNum);
CHECK_1BYTE_WasaDbg( pHeaderDbl + 1, pHeaderDbl + 1);
        for( pCurrentDbl = pHeaderDbl->pNext; pCurrentDbl != pEndDbl; pCurrentDbl = pNextDbl){
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1);
            pNextDbl = pCurrentDbl->pNext;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl, 1);
            // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + listNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + listNum);
            ( *( gppFreeElementFunc_WasaList + listNum))( pCurrentDbl);
        }
        // N̕tւB
CHECK_1BYTE_WasaDbg( pHeaderDbl + 1, pHeaderDbl + 1);
        pHeaderDbl->pNext = pEndDbl;
CHECK_1BYTE_WasaDbg( pEndDbl + 1, pEndDbl + 1);
        pEndDbl->pPrev = pHeaderDbl;
    }else{
        DEBUG_BREAKPOINT;
        return;
    }
//CHECK_PTR_WasaDbg( *( gpNumberOfElement_WasaList + listNum));
CHECK_PTR_WasaDbg( gpNumberOfElement_WasaList, gpNumberOfElement_WasaList + listNum);
    *( gpNumberOfElement_WasaList + listNum) = 0;
// Xg̐`FbN( *( gpNumberOfElement_WasaList + listNum) 񃋁[vă`FbN)B
CHECK_LINKLIST( listNum);
}

//////////////////////////////////////////////////////////////////////////////
// w肵ʒũXgvf폜AɎw肵Xgvf}( P͎Ԃ܂)B
//////////////////////////////////////////////////////////////////////////////
void FnRemoveAndInsert_WasaList(
    int listNum,
    void* pLocateOfElement, //     폜郊Xgvf̃AhXB
    void* pInsertElement    //     mۍς݃Xgvfւ̃|C^B
#ifndef NDEBUG
	, int size,
    char* errFileName,
    int errLine
#endif
)
{
    struct SIMPLE_LIST* pHeader;
    struct SIMPLE_LIST* pPrev;
    struct SIMPLE_LIST* pCurrent;
    struct SIMPLE_LIST* pNext;
    struct DOUBLE_LIST* pPrevDbl;
    struct DOUBLE_LIST* pCurrentDbl;
    struct DOUBLE_LIST* pNextDbl;

    CHECK_INIT( "FnRemoveAndInsert_WasaList", errFileName, errLine, return);
    CHECK_LINK_NUM( listNum, "FnRemoveAndInsert_WasaList", errFileName, errLine, return);
    CHECK_PTR( pLocateOfElement, "FnRemoveAndInsert_WasaList", "param2", errFileName, errLine, return);
    CHECK_PTR( pInsertElement, "FnRemoveAndInsert_WasaList", "param3", errFileName, errLine, return);
    CHECK_ELEMENT( listNum, pLocateOfElement, "FnRemoveAndInsert_WasaList", "param2", errFileName, errLine, return);
    CHECK_IN_ELEMENT( listNum, pInsertElement, "FnRemoveAndInsert_WasaList", "param3", errFileName, errLine, return);

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pHeader);
    FnSetNull_Wasa(( void**)&pPrev);
    FnSetNull_Wasa(( void**)&pCurrent);
    FnSetNull_Wasa(( void**)&pNext);
    FnSetNull_Wasa(( void**)&pPrevDbl);
    FnSetNull_Wasa(( void**)&pCurrentDbl);
    FnSetNull_Wasa(( void**)&pNextDbl);
#endif

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
        // pPrev TB
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        pHeader = ( struct SIMPLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
        pPrev = pHeader;
//CHECK_PTR_WasaDbg( *pPrev);
CHECK_1BYTE_WasaDbg( pPrev + 1, pPrev + 1);
        for( pCurrent = pPrev->pNext; pCurrent != pLocateOfElement; pCurrent = pCurrent->pNext){
            pPrev = pCurrent;
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
        }
        assert( pCurrent == pLocateOfElement);
        // pNext ̐ݒB
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
        pNext = pCurrent->pNext;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrent + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrent, 1);
        // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + listNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + listNum);
        ( *( gppFreeElementFunc_WasaList + listNum))( pCurrent);
        // pCurrent }vfɂB
        pCurrent = ( struct SIMPLE_LIST*)pInsertElement;
        // N̕tւB
//CHECK_PTR_WasaDbg( *pPrev);
CHECK_1BYTE_WasaDbg( pPrev + 1, pPrev + 1);
        pPrev->pNext = pCurrent;
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
        pCurrent->pNext = pNext;
        // XgI[ɗvf}AXgGhύXB
        if( pNext == NULL){
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
            *( gppListInfoEnd_WasaList + listNum) = pCurrent;
        }
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
        // pPrevDbl, pNextDbg ɗvfLĂāApCurrentDbl ɍ폜vfݒB
        pCurrentDbl = ( struct DOUBLE_LIST*)pLocateOfElement;
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1);
        pPrevDbl = pCurrentDbl->pPrev;
        pNextDbl = pCurrentDbl->pNext;
// prev, next |C^̌̃擪ɈړB
FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl + 1);
ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl, 1);
        // XgvfJB
//CHECK_PTR_WasaDbg( *( gppFreeElementFunc_WasaList + listNum));
CHECK_PTR_WasaDbg( gppFreeElementFunc_WasaList, gppFreeElementFunc_WasaList + listNum);
        ( *( gppFreeElementFunc_WasaList + listNum))( pCurrentDbl);
        // Jg}vfɂB
        pCurrentDbl = ( struct DOUBLE_LIST*)pInsertElement;
// 񂩂 prev, next |C^폜B
//FREE_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl);
//ALLOC_MEMINFO_OF_ALLOCATION_WasaDbg( pCurrentDbl + 1, size - sizeof( *pCurrentDbl));
DELETE_LINK_PATRS_MEMINFO( pCurrentDbl, size);
        // N̕tւB
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1);
        pCurrentDbl->pPrev = pPrevDbl;
        pCurrentDbl->pNext = pNextDbl;
CHECK_1BYTE_WasaDbg( pPrevDbl + 1, pPrevDbl + 1);
        pPrevDbl->pNext = pCurrentDbl;
CHECK_1BYTE_WasaDbg( pNextDbl + 1, pNextDbl + 1);
        pNextDbl->pPrev = pCurrentDbl;
    }else{
        DEBUG_BREAKPOINT;
        return;
    }
// Xg̐`FbN( *( gpNumberOfElement_WasaList + listNum) 񃋁[vă`FbN)B
CHECK_LINKLIST( listNum);
}

//////////////////////////////////////////////////////////////////////////////
// Xgvf̌ԂB
//////////////////////////////////////////////////////////////////////////////
// ߂l       Xgvf̌B
int FnGetCount_WasaList(
    int listNum
#ifndef NDEBUG
    , char* errFileName,
    int errLine
#endif
)
{
    int result;

    CHECK_INIT( "FnGetCount_WasaList", errFileName, errLine, return( -1));
    CHECK_LINK_NUM( listNum, "FnGetCount_WasaList", errFileName, errLine, return( -1));

//CHECK_PTR_WasaDbg( *( gpNumberOfElement_WasaList + listNum));
CHECK_PTR_WasaDbg( gpNumberOfElement_WasaList, gpNumberOfElement_WasaList + listNum);
    result = *( gpNumberOfElement_WasaList + listNum);

    return( result);
}

//////////////////////////////////////////////////////////////////////////////
// w肵ʒũXgvf擪Ɍq( P͎Ԃ܂)B
//////////////////////////////////////////////////////////////////////////////
void FnMoveHead_WasaList(
    int listNum,
    void* pLocateOfElement //     ړ郊Xgvf̃AhXB
#ifndef NDEBUG
    , char* errFileName,
    int errLine
#endif
)
{
    struct SIMPLE_LIST* pHeader;
    struct SIMPLE_LIST* pPrev;
    struct SIMPLE_LIST* pCurrent;
    struct DOUBLE_LIST* pHeaderDbl;
    struct DOUBLE_LIST* pPrevDbl;
    struct DOUBLE_LIST* pCurrentDbl;
    struct DOUBLE_LIST* pNextDbl;

    CHECK_INIT( "FnRemoveAndInsert_WasaList", errFileName, errLine, return);
    CHECK_LINK_NUM( listNum, "FnRemoveAndInsert_WasaList", errFileName, errLine, return);
    CHECK_PTR( pLocateOfElement, "FnRemoveAndInsert_WasaList", "param2", errFileName, errLine, return);
    CHECK_ELEMENT( listNum, pLocateOfElement, "FnRemoveAndInsert_WasaList", "param2", errFileName, errLine, return);

#ifndef NDEBUG
    FnSetNull_Wasa(( void**)&pHeader);
    FnSetNull_Wasa(( void**)&pPrev);
    FnSetNull_Wasa(( void**)&pCurrent);
    FnSetNull_Wasa(( void**)&pHeaderDbl);
    FnSetNull_Wasa(( void**)&pPrevDbl);
    FnSetNull_Wasa(( void**)&pCurrentDbl);
    FnSetNull_Wasa(( void**)&pNextDbl);
#endif

//CHECK_PTR_WasaDbg( *( gpListKind_WasaList + listNum));
CHECK_PTR_WasaDbg( gpListKind_WasaList, gpListKind_WasaList + listNum);
    if( *( gpListKind_WasaList + listNum) & KIND_SINGLE_WasaList){
        // pPrev TB
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
        pHeader = ( struct SIMPLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
        pPrev = pHeader;
//CHECK_PTR_WasaDbg( *pPrev);
CHECK_1BYTE_WasaDbg( pPrev + 1, pPrev + 1);
        for( pCurrent = pPrev->pNext; pCurrent != pLocateOfElement; pCurrent = pCurrent->pNext){
            pPrev = pCurrent;
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
        }
        assert( pCurrent == pLocateOfElement);
        // N̕tւB
//CHECK_PTR_WasaDbg( *pPrev);
CHECK_1BYTE_WasaDbg( pPrev + 1, pPrev + 1);
//CHECK_PTR_WasaDbg( *pCurrent);
CHECK_1BYTE_WasaDbg( pCurrent + 1, pCurrent + 1);
        pPrev->pNext = pCurrent->pNext;
//CHECK_PTR_WasaDbg( *pHeader);
CHECK_1BYTE_WasaDbg( pHeader + 1, pHeader + 1);
		pCurrent->pNext = pHeader->pNext;
		pHeader->pNext = pCurrent;
        // XgI[ɗvf}AXgGhύXB
        if( pPrev->pNext == NULL){
//CHECK_PTR_WasaDbg( *( gppListInfoEnd_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoEnd_WasaList, gppListInfoEnd_WasaList + listNum);
            *( gppListInfoEnd_WasaList + listNum) = pPrev;
        }
    }else if( *( gpListKind_WasaList + listNum) & KIND_DOUBLE_WasaList){
        // pPrevDbl, pNextDbg ɗvfLĂāApCurrentDbl ɍ폜vfݒB
        pCurrentDbl = ( struct DOUBLE_LIST*)pLocateOfElement;
CHECK_1BYTE_WasaDbg( pCurrentDbl + 1, pCurrentDbl + 1);
        pPrevDbl = pCurrentDbl->pPrev;
        pNextDbl = pCurrentDbl->pNext;
        // N̕tւB
CHECK_1BYTE_WasaDbg( pPrevDbl + 1, pPrevDbl + 1);
		pPrevDbl->pNext = pNextDbl;
CHECK_1BYTE_WasaDbg( pNextDbl + 1, pNextDbl + 1);
		pNextDbl->pPrev = pPrevDbl;
//CHECK_PTR_WasaDbg( *( gppListInfoHeader_WasaList + listNum));
CHECK_PTR_WasaDbg( gppListInfoHeader_WasaList, gppListInfoHeader_WasaList + listNum);
		pHeaderDbl = ( struct DOUBLE_LIST*)*( gppListInfoHeader_WasaList + listNum);
        pCurrentDbl->pPrev = pHeaderDbl;
CHECK_1BYTE_WasaDbg( pHeaderDbl + 1, pHeaderDbl + 1);
        pCurrentDbl->pNext = pHeaderDbl->pNext;
CHECK_1BYTE_WasaDbg( pHeaderDbl->pNext + 1, pHeaderDbl->pNext + 1);
		pHeaderDbl->pNext->pPrev = pCurrentDbl;
		pHeaderDbl->pNext = pCurrentDbl;
    }else{
        DEBUG_BREAKPOINT;
        return;
    }
// Xg̐`FbN( *( gpNumberOfElement_WasaList + listNum) 񃋁[vă`FbN)B
CHECK_LINKLIST( listNum);
}
