#include <windows.h>
#include "../../../_WasaLib/_Cover.h" // __inline ֐̂ _WasaDbg.h ̌ŃCN[h

typedef int ( WINAPI* P_FN_SEVEN_ZIP)( const HWND _hwnd, LPCSTR _szCmdLine, LPSTR _szOutput, const DWORD _dwSize);
static P_FN_SEVEN_ZIP gpFnSevenZip;
static HINSTANCE ghSevenZipDLL;

// yhoCu
void FnCreateSevenZip( void)
{
	// ZIP  DLL [h
	ghSevenZipDLL = ::LoadLibrary( "7-zip32.dll");
	if(( HINSTANCE)HINSTANCE_ERROR > ghSevenZipDLL){
		// G[
		::MessageBox( NULL, "7-zip32.dll [ho܂B", "G[", MB_OK | MB_TASKMODAL);
		exit( -1);
	}
	// ֐ʒu擾
	gpFnSevenZip = ( P_FN_SEVEN_ZIP)::GetProcAddress( ghSevenZipDLL, "SevenZip");
	if( gpFnSevenZip == NULL){
		// G[
		::MessageBox( NULL, "SevenZip ̊֐ʒu擾o܂B", "G[", MB_OK | MB_TASKMODAL);
		exit( -1);
	}
}

// t@Cyhok܂͓WJ
void FnSevenZip(
	char* commandBuffer,	// 		R}h
	char* fileName,			// 		kt@C
	char* zipFileName)		// 		kt@C
{
	FILE* pFile = NULL;		MEMINFO_WasaDbg( pFile);
	char* pZipBuffer = NULL;
	int zipBufferSize;

	if( 'u' == commandBuffer[ 0]){
		// t@CI[v
		FN_FOPEN( fileName, "rb", pFile);
		// t@C|C^t@CTCY擾
		zipBufferSize = FnGetFileSize( pFile);
		// m
		if( NULL == (( void*&)pZipBuffer = ::GlobalAlloc( GMEM_FIXED, zipBufferSize))){
			::MessageBox( NULL, "mێsB", "G[", MB_OK | MB_TASKMODAL);
			exit( -1);
		}
		// rbg}bvt@CN[Y
		FN_FCLOSE( pFile);
// yhot@C݂Ȃ͂
assert( _access( zipFileName, 00));
	}
	// DLL  SevenZip ֐̌Ăяo
	if(( *gpFnSevenZip)( gHWnd, commandBuffer, pZipBuffer, zipBufferSize)){
		::MessageBox( NULL, "SevenZip ֐sB", "G[", MB_OK | MB_TASKMODAL);
		exit( -1);
	}
	if( 'u' == commandBuffer[ 0]){
		// yhoobt@J
		::GlobalFree( pZipBuffer);
	}
}

// t@Cyhok
void FnCompressSevenZip(
	char* fileName,		// 		kt@C
	char* zipFileName)	// 		kt@C
{
	char commandBuffer[ MAX_PATH * 2 + 4];	MEMINFO_WasaDbg( commandBuffer);

	_snprintf( commandBuffer, sizeof( commandBuffer), "u %s %s", zipFileName, fileName);
	// t@Cyhok܂͓WJ
	FnSevenZip(	commandBuffer, fileName, zipFileName);
}

// yhot@CWJ
void FnExpandSevenZip( char* zipFileName)		// 		WJyhot@C
{
	char commandBuffer[ MAX_PATH * 2 + 4];	MEMINFO_WasaDbg( commandBuffer);

	_snprintf( commandBuffer, sizeof( commandBuffer), "e -aoa %s", zipFileName);
	// t@Cyhok܂͓WJ
	FnSevenZip(	commandBuffer, "", zipFileName);
}

// yhoCuj
void FnDestroySevenZip( void)
{
	// DLL 
	::FreeLibrary( ghSevenZipDLL);
}
